From 1d465f57d1c4fd407b70a6bbcf18bc2986f355b7 Mon Sep 17 00:00:00 2001
From: Jiri Kubias <jiri.kubias@addat.cz>
Date: Wed, 16 Mar 2011 16:07:42 +0100
Subject: [PATCH] mach-lpc17cmsis - New lpc21isp - now luch the code after flashing

New lpc21isp 1.81 fixed firmware startup after flashing new code. The old version didnt launch the code.
---
 arch/arm/mach-lpc17cmsis/tools/lpc21isp/adprog.c   |  648 ++++++++++----------
 arch/arm/mach-lpc17cmsis/tools/lpc21isp/adprog.h   |   92 ++--
 arch/arm/mach-lpc17cmsis/tools/lpc21isp/gpl.txt    |  674 ++++++++++++++++++++
 .../mach-lpc17cmsis/tools/lpc21isp/lgpl-3.0.txt    |  165 +++++
 arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpc21isp.c |   25 +-
 arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpc21isp.h |  576 +++++++++---------
 arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.c  |  302 +++++----
 .../arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.dsp |  200 +++---
 .../arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.dsw |   58 +-
 arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.h  |  250 ++++----
 arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcterm.c  |  274 ++++----
 arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcterm.h  |   84 ++--
 12 files changed, 2117 insertions(+), 1231 deletions(-)
 create mode 100644 arch/arm/mach-lpc17cmsis/tools/lpc21isp/gpl.txt
 create mode 100644 arch/arm/mach-lpc17cmsis/tools/lpc21isp/lgpl-3.0.txt

diff --git a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/adprog.c b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/adprog.c
index ab95bfe..f449cd6 100644
--- a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/adprog.c
+++ b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/adprog.c
@@ -1,324 +1,324 @@
-/******************************************************************************
-
-Project:           Portable command line ISP for Philips LPC2000 family
-                   and Analog Devices ADUC70xx
-
-Filename:          adprog.c
-
-Compiler:          Microsoft VC 6/7, GCC Cygwin, GCC Linux, GCC ARM ELF
-
-Author:            Martin Maurer (Martin.Maurer@clibb.de)
-
-Copyright:         (c) Martin Maurer 2003-2008, All rights reserved
-Portions Copyright (c) by Aeolus Development 2004 http://www.aeolusdevelopment.com
-
-    This file is part of lpc21isp.
-
-    lpc21isp is free software: you can redistribute it and/or modify
-    it under the terms of the GNU Lesser General Public License as published by
-    the Free Software Foundation, either version 3 of the License, or
-    any later version.
-
-    lpc21isp is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU Lesser General Public License for more details.
-
-    You should have received a copy of the GNU Lesser General Public License
-    and GNU General Public License along with lpc21isp.
-    If not, see <http://www.gnu.org/licenses/>.
-*/
-
-#if defined(_WIN32)
-#if !defined __BORLANDC__
-#include "StdAfx.h"
-#endif
-#endif // defined(_WIN32)
-#include "lpc21isp.h"
-
-#ifdef AD_SUPPORT
-#include "adprog.h"
-
-/***************************** AnalogDevicesSync ************************/
-/**  Attempt to synchronize with an Analog Device ARM micro.  Sends a
-backspace and reads back the microcontrollers response.  Performs
-multiple retries. Exits the program on error, returns to caller in the
-case of success.
-*/
-static void AnalogDevicesSync(ISP_ENVIRONMENT *IspEnvironment)
-{
-    BINARY sync;                        /* Holds sync command.          */
-    AD_SYNC_RESPONSE response;          /* Response from micro.         */
-    int sync_attempts;                  /* Number of retries.           */
-
-    /*  Make sure we don't read garbage later instead of the        */
-    /* response we expect from the micro.                           */
-    ClearSerialPortBuffers(IspEnvironment);
-
-    DebugPrintf(2, "Synchronizing\n"); /* Progress report.             */
-
-    sync = ANALOG_DEVICES_SYNC_CHAR;    /* Build up sync command.       */
-
-    /*  Perform the actual sync attempt.  First send the sync       */
-    /* character, the attempt to read back the response.  For the   */
-    /* AD ARM micro this is a fixed length block.  If response is   */
-    /* received attempt to validate it by comparing the first       */
-    /* characters to those expected.  If the received block does    */
-    /* not validate or is incomplete empty the serial buffer and    */
-    /* retry.                                                       */
-    for (sync_attempts = 0; sync_attempts < 5; sync_attempts++)
-    {
-        SendComPortBlock(IspEnvironment, &sync, 1);
-
-        if (ReceiveComPortBlockComplete(IspEnvironment, &response, sizeof(response),
-            500) == 0)
-        {
-
-            if (memcmp(response.product_id, ANALOG_DEVICES_SYNC_RESPONSE,
-                ANALOG_DEVICES_SYNC_SIZE) == 0)
-            {
-                return;
-            }
-            else
-            {
-                DumpString(3, &response, sizeof(response),
-                    "Unexpected response to sync attempt ");
-            }
-        }
-        else
-        {
-            DebugPrintf(3, "No (or incomplete) answer on sync attempt\n");
-        }
-
-        ClearSerialPortBuffers(IspEnvironment);
-    }
-
-    DebugPrintf(1, "No (or unacceptable) answer on sync attempt\n");
-    exit(4);
-}
-
-typedef struct {
-    char start1;
-    char start2;
-    BINARY bytes;
-    char cmd;
-    BINARY address_h;
-    BINARY address_u;
-    BINARY address_m;
-    BINARY address_l;
-    BINARY data[251];
-} AD_PACKET;
-
-/***************************** AnalogDevicesFormPacket ******************/
-/**  Create an Analog Devices communication packet from the constituent
-elements.
-\param [in] cmd The command being sent, one of 'E' for erase, 'W' for
-write, 'V' for verify or 'R' for run..
-\param [in] no_bytes the number of data bytes to send with the command in
-the packet.
-\param [in] address the address to apply the command to.
-\param [in] data the data to send with the packet, may be null if no_bytes
-is zero.
-\param[out] packet that will be filled.
-*/
-static void AnalogDevicesFormPacket(ISP_ENVIRONMENT *IspEnvironment,
-                                                char cmd, int no_bytes, unsigned int address,
-                                                const void *data, AD_PACKET *packet)
-{
-    BINARY checksum;
-    const BINARY *data_in;
-    int i;
-
-    (void)IspEnvironment; /* never used in this function */
-
-    /*  Some sanity checking on the arguments.  These should only   */
-    /* fail if there is a bug in the caller.                        */
-    /*  Check 1) that the number of data bytes is in an acceptable  */
-    /* range, 2) that we have a non-null pointer if data is being   */
-    /* put in the packet and 3) that we have a non-null pointer to  */
-    /* the packet to be filled. We just exit with an error message  */
-    /* if any of these tests fail.                                  */
-    if ((no_bytes < 0) || (no_bytes > 250))
-    {
-        DebugPrintf(1,
-            "The number of bytes (%d) passed to FormPacket is invalid.\n",
-            no_bytes);
-        exit(-1);
-    }
-    if ((data == 0) && (no_bytes != 0))
-    {
-        DebugPrintf(1,
-            "A null pointer to data paased to FormPacket when data was expected.\n");
-        exit(-1);
-    }
-    if (packet == 0)
-    {
-        DebugPrintf(1,
-            "A null packet pointer was passed to FormPacket.\n");
-        exit(-1);
-    }
-
-    checksum = 0;               /*  Checksum starts at zero.            */
-
-    data_in = (BINARY*) data;             /*  Pointer pun so we can walk through  */
-    /* the data.                            */
-
-    packet->start1 = 0x7;       /*  The start of the packet is constant.*/
-    packet->start2 = 0xE;
-
-    /*  Fill in the rest of the packet and calculate the checksum   */
-    /* as we go.                                                    */
-
-    /* The number of bytes is the number of data bytes + the        */
-    /* address bytes + the command byte.                            */
-    packet->bytes = (BINARY)(no_bytes + 5);
-
-    checksum += packet->bytes;
-
-    /*  The command for the packet being sent.  No error checking   */
-    /* done on this.                                                */
-    packet->cmd = cmd;
-
-    checksum += cmd;
-
-    /*  Now break up the address and place in the proper packet     */
-    /* locations.                                                   */
-    packet->address_l = (BINARY)(address & 0xFF);
-    packet->address_m = (BINARY)((address >> 8) & 0xFF);
-    packet->address_u = (BINARY)((address >> 16) & 0xFF);
-    packet->address_h = (BINARY)((address >> 24) & 0xFF);
-
-    checksum += packet->address_l;
-    checksum += packet->address_m;
-    checksum += packet->address_u;
-    checksum += packet->address_h;
-
-    /*  Copy the data bytes into the packet.  We could use memcpy   */
-    /* but we have to calculate the checksum anyway.                */
-    for (i = 0; i < no_bytes; i++)
-    {
-        packet->data[i] = data_in[i];
-        checksum += data_in[i];
-    }
-
-    /*  Finally, add the checksum to the end of the packet.         */
-    packet->data[i] = (BINARY)-checksum;
-}
-
-/***************************** AnalogDevicesSendPacket ******************/
-/**  Send a previously form Analog Devices communication.  Retry a
-couple of times if needed but fail by exiting the program if no ACK is
-forthcoming.
-\param [in] packet the packet to send.
-*/
-static void AnalogDevicesSendPacket(ISP_ENVIRONMENT *IspEnvironment,
-                                                const AD_PACKET * packet)
-{
-    BINARY response;
-    int retry = 0;
-
-    do {
-        retry++;
-
-        /*  Make sure we don't read garbage later instead of    */
-        /* the response we expect from the micro.               */
-        ClearSerialPortBuffers(IspEnvironment);
-
-        /*  Send the packet, the size is the number of data     */
-        /* bytes in the packet plus 3 bytes worth of header     */
-        /* plus checksum.                                       */
-        SendComPortBlock(IspEnvironment, packet, packet->bytes + 4);
-
-        /*  Receive the response and check, return to caller    */
-        /* if successful.                                       */
-        if (ReceiveComPortBlockComplete(IspEnvironment, &response, 1, 5000) == 0)
-        {
-            if (response == ANALOG_DEVICES_ACK)
-            {
-                DebugPrintf(3, "Packet Sent\n");
-                return;
-            }
-            if (response != ANALOG_DEVICES_NAK)
-            {
-                DebugPrintf(3, "Unexpected response to packet (%x)\n", (int)response);
-            }
-            DebugPrintf(2, "*");
-        }
-    } while (retry < 3);
-
-    DebugPrintf(1, "Send packet failed\n");
-    exit(-1);
-}
-
-/***************************** AnalogDevicesErase ***********************/
-/**  Erase the Analog Devices micro.  We take the simple way out and
-just erase the whole thing.
-*/
-static void AnalogDevicesErase(ISP_ENVIRONMENT *IspEnvironment)
-{
-    BINARY pages;
-    AD_PACKET packet;
-
-    pages = 0;
-    DebugPrintf(2, "Erasing .. ");
-    AnalogDevicesFormPacket(IspEnvironment, 'E', 1, 0, &pages, &packet);
-    AnalogDevicesSendPacket(IspEnvironment, &packet);
-    DebugPrintf(2, "Erased\n");
-}
-
-#define AD_PACKET_SIZE (250)
-
-/***************************** AnalogDevicesWrite ***********************/
-/**  Write the program.
-\param [in] data the program to download to the micro.
-\param [in] address where to start placing the program.
-\param [in] bytes the size of the progrm to download.
-*/
-static void AnalogDevicesWrite(ISP_ENVIRONMENT *IspEnvironment,
-                                         const void *data, long address, size_t bytes)
-{
-    AD_PACKET packet;
-    const BINARY *prog_data;
-
-    DebugPrintf(2, "Writing %d bytes ", bytes);
-    prog_data = (const BINARY*) data;
-    while (bytes > AD_PACKET_SIZE)
-    {
-        AnalogDevicesFormPacket(IspEnvironment, 'W', AD_PACKET_SIZE, address, prog_data, &packet);
-        AnalogDevicesSendPacket(IspEnvironment, &packet);
-        address += AD_PACKET_SIZE;
-        prog_data += AD_PACKET_SIZE;
-        bytes -= AD_PACKET_SIZE;
-        DebugPrintf(2, ".");
-    }
-    if (bytes > 0)
-    {
-        AnalogDevicesFormPacket(IspEnvironment, 'W', bytes, address, prog_data, &packet);
-        AnalogDevicesSendPacket(IspEnvironment, &packet);
-        DebugPrintf(2, ".");
-    }
-}
-
-/***************************** AnalogDevicesDownload ********************/
-/**  Perform the download into an Analog Devices micro.  As a quick and
-* dirty hack against flash relocations at 0x80000
-* \return 0 if ok, error code else
-* \ToDo: possible to implement the return value instead of calling
-* exit() in sub-functions
-*/
-int AnalogDevicesDownload(ISP_ENVIRONMENT *IspEnvironment)
-{
-    AnalogDevicesSync(IspEnvironment);
-    AnalogDevicesErase(IspEnvironment);
-    if (IspEnvironment->BinaryLength > 0x80000)
-    {
-        DebugPrintf(2, "Note:  Flash remapped 0x80000 to 0.\n");
-        AnalogDevicesWrite(IspEnvironment, IspEnvironment->BinaryContent + 0x80000, 0, IspEnvironment->BinaryLength-0x80000);
-    }
-    else
-    {
-        AnalogDevicesWrite(IspEnvironment, IspEnvironment->BinaryContent, 0, IspEnvironment->BinaryLength);
-    }
-    return (0);
-}
-#endif // AD_SUPPORT
+/******************************************************************************
+
+Project:           Portable command line ISP for Philips LPC2000 family
+                   and Analog Devices ADUC70xx
+
+Filename:          adprog.c
+
+Compiler:          Microsoft VC 6/7, GCC Cygwin, GCC Linux, GCC ARM ELF
+
+Author:            Martin Maurer (Martin.Maurer@clibb.de)
+
+Copyright:         (c) Martin Maurer 2003-2008, All rights reserved
+Portions Copyright (c) by Aeolus Development 2004 http://www.aeolusdevelopment.com
+
+    This file is part of lpc21isp.
+
+    lpc21isp is free software: you can redistribute it and/or modify
+    it under the terms of the GNU Lesser General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    any later version.
+
+    lpc21isp is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    and GNU General Public License along with lpc21isp.
+    If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#if defined(_WIN32)
+#if !defined __BORLANDC__
+#include "StdAfx.h"
+#endif
+#endif // defined(_WIN32)
+#include "lpc21isp.h"
+
+#ifdef AD_SUPPORT
+#include "adprog.h"
+
+/***************************** AnalogDevicesSync ************************/
+/**  Attempt to synchronize with an Analog Device ARM micro.  Sends a
+backspace and reads back the microcontrollers response.  Performs
+multiple retries. Exits the program on error, returns to caller in the
+case of success.
+*/
+static void AnalogDevicesSync(ISP_ENVIRONMENT *IspEnvironment)
+{
+    BINARY sync;                        /* Holds sync command.          */
+    AD_SYNC_RESPONSE response;          /* Response from micro.         */
+    int sync_attempts;                  /* Number of retries.           */
+
+    /*  Make sure we don't read garbage later instead of the        */
+    /* response we expect from the micro.                           */
+    ClearSerialPortBuffers(IspEnvironment);
+
+    DebugPrintf(2, "Synchronizing\n"); /* Progress report.             */
+
+    sync = ANALOG_DEVICES_SYNC_CHAR;    /* Build up sync command.       */
+
+    /*  Perform the actual sync attempt.  First send the sync       */
+    /* character, the attempt to read back the response.  For the   */
+    /* AD ARM micro this is a fixed length block.  If response is   */
+    /* received attempt to validate it by comparing the first       */
+    /* characters to those expected.  If the received block does    */
+    /* not validate or is incomplete empty the serial buffer and    */
+    /* retry.                                                       */
+    for (sync_attempts = 0; sync_attempts < 5; sync_attempts++)
+    {
+        SendComPortBlock(IspEnvironment, &sync, 1);
+
+        if (ReceiveComPortBlockComplete(IspEnvironment, &response, sizeof(response),
+            500) == 0)
+        {
+
+            if (memcmp(response.product_id, ANALOG_DEVICES_SYNC_RESPONSE,
+                ANALOG_DEVICES_SYNC_SIZE) == 0)
+            {
+                return;
+            }
+            else
+            {
+                DumpString(3, &response, sizeof(response),
+                    "Unexpected response to sync attempt ");
+            }
+        }
+        else
+        {
+            DebugPrintf(3, "No (or incomplete) answer on sync attempt\n");
+        }
+
+        ClearSerialPortBuffers(IspEnvironment);
+    }
+
+    DebugPrintf(1, "No (or unacceptable) answer on sync attempt\n");
+    exit(4);
+}
+
+typedef struct {
+    char start1;
+    char start2;
+    BINARY bytes;
+    char cmd;
+    BINARY address_h;
+    BINARY address_u;
+    BINARY address_m;
+    BINARY address_l;
+    BINARY data[251];
+} AD_PACKET;
+
+/***************************** AnalogDevicesFormPacket ******************/
+/**  Create an Analog Devices communication packet from the constituent
+elements.
+\param [in] cmd The command being sent, one of 'E' for erase, 'W' for
+write, 'V' for verify or 'R' for run..
+\param [in] no_bytes the number of data bytes to send with the command in
+the packet.
+\param [in] address the address to apply the command to.
+\param [in] data the data to send with the packet, may be null if no_bytes
+is zero.
+\param[out] packet that will be filled.
+*/
+static void AnalogDevicesFormPacket(ISP_ENVIRONMENT *IspEnvironment,
+                                                char cmd, int no_bytes, unsigned int address,
+                                                const void *data, AD_PACKET *packet)
+{
+    BINARY checksum;
+    const BINARY *data_in;
+    int i;
+
+    (void)IspEnvironment; /* never used in this function */
+
+    /*  Some sanity checking on the arguments.  These should only   */
+    /* fail if there is a bug in the caller.                        */
+    /*  Check 1) that the number of data bytes is in an acceptable  */
+    /* range, 2) that we have a non-null pointer if data is being   */
+    /* put in the packet and 3) that we have a non-null pointer to  */
+    /* the packet to be filled. We just exit with an error message  */
+    /* if any of these tests fail.                                  */
+    if ((no_bytes < 0) || (no_bytes > 250))
+    {
+        DebugPrintf(1,
+            "The number of bytes (%d) passed to FormPacket is invalid.\n",
+            no_bytes);
+        exit(-1);
+    }
+    if ((data == 0) && (no_bytes != 0))
+    {
+        DebugPrintf(1,
+            "A null pointer to data paased to FormPacket when data was expected.\n");
+        exit(-1);
+    }
+    if (packet == 0)
+    {
+        DebugPrintf(1,
+            "A null packet pointer was passed to FormPacket.\n");
+        exit(-1);
+    }
+
+    checksum = 0;               /*  Checksum starts at zero.            */
+
+    data_in = (BINARY*) data;             /*  Pointer pun so we can walk through  */
+    /* the data.                            */
+
+    packet->start1 = 0x7;       /*  The start of the packet is constant.*/
+    packet->start2 = 0xE;
+
+    /*  Fill in the rest of the packet and calculate the checksum   */
+    /* as we go.                                                    */
+
+    /* The number of bytes is the number of data bytes + the        */
+    /* address bytes + the command byte.                            */
+    packet->bytes = (BINARY)(no_bytes + 5);
+
+    checksum += packet->bytes;
+
+    /*  The command for the packet being sent.  No error checking   */
+    /* done on this.                                                */
+    packet->cmd = cmd;
+
+    checksum += cmd;
+
+    /*  Now break up the address and place in the proper packet     */
+    /* locations.                                                   */
+    packet->address_l = (BINARY)(address & 0xFF);
+    packet->address_m = (BINARY)((address >> 8) & 0xFF);
+    packet->address_u = (BINARY)((address >> 16) & 0xFF);
+    packet->address_h = (BINARY)((address >> 24) & 0xFF);
+
+    checksum += packet->address_l;
+    checksum += packet->address_m;
+    checksum += packet->address_u;
+    checksum += packet->address_h;
+
+    /*  Copy the data bytes into the packet.  We could use memcpy   */
+    /* but we have to calculate the checksum anyway.                */
+    for (i = 0; i < no_bytes; i++)
+    {
+        packet->data[i] = data_in[i];
+        checksum += data_in[i];
+    }
+
+    /*  Finally, add the checksum to the end of the packet.         */
+    packet->data[i] = (BINARY)-checksum;
+}
+
+/***************************** AnalogDevicesSendPacket ******************/
+/**  Send a previously form Analog Devices communication.  Retry a
+couple of times if needed but fail by exiting the program if no ACK is
+forthcoming.
+\param [in] packet the packet to send.
+*/
+static void AnalogDevicesSendPacket(ISP_ENVIRONMENT *IspEnvironment,
+                                                const AD_PACKET * packet)
+{
+    BINARY response;
+    int retry = 0;
+
+    do {
+        retry++;
+
+        /*  Make sure we don't read garbage later instead of    */
+        /* the response we expect from the micro.               */
+        ClearSerialPortBuffers(IspEnvironment);
+
+        /*  Send the packet, the size is the number of data     */
+        /* bytes in the packet plus 3 bytes worth of header     */
+        /* plus checksum.                                       */
+        SendComPortBlock(IspEnvironment, packet, packet->bytes + 4);
+
+        /*  Receive the response and check, return to caller    */
+        /* if successful.                                       */
+        if (ReceiveComPortBlockComplete(IspEnvironment, &response, 1, 5000) == 0)
+        {
+            if (response == ANALOG_DEVICES_ACK)
+            {
+                DebugPrintf(3, "Packet Sent\n");
+                return;
+            }
+            if (response != ANALOG_DEVICES_NAK)
+            {
+                DebugPrintf(3, "Unexpected response to packet (%x)\n", (int)response);
+            }
+            DebugPrintf(2, "*");
+        }
+    } while (retry < 3);
+
+    DebugPrintf(1, "Send packet failed\n");
+    exit(-1);
+}
+
+/***************************** AnalogDevicesErase ***********************/
+/**  Erase the Analog Devices micro.  We take the simple way out and
+just erase the whole thing.
+*/
+static void AnalogDevicesErase(ISP_ENVIRONMENT *IspEnvironment)
+{
+    BINARY pages;
+    AD_PACKET packet;
+
+    pages = 0;
+    DebugPrintf(2, "Erasing .. ");
+    AnalogDevicesFormPacket(IspEnvironment, 'E', 1, 0, &pages, &packet);
+    AnalogDevicesSendPacket(IspEnvironment, &packet);
+    DebugPrintf(2, "Erased\n");
+}
+
+#define AD_PACKET_SIZE (250)
+
+/***************************** AnalogDevicesWrite ***********************/
+/**  Write the program.
+\param [in] data the program to download to the micro.
+\param [in] address where to start placing the program.
+\param [in] bytes the size of the progrm to download.
+*/
+static void AnalogDevicesWrite(ISP_ENVIRONMENT *IspEnvironment,
+                                         const void *data, long address, size_t bytes)
+{
+    AD_PACKET packet;
+    const BINARY *prog_data;
+
+    DebugPrintf(2, "Writing %d bytes ", bytes);
+    prog_data = (const BINARY*) data;
+    while (bytes > AD_PACKET_SIZE)
+    {
+        AnalogDevicesFormPacket(IspEnvironment, 'W', AD_PACKET_SIZE, address, prog_data, &packet);
+        AnalogDevicesSendPacket(IspEnvironment, &packet);
+        address += AD_PACKET_SIZE;
+        prog_data += AD_PACKET_SIZE;
+        bytes -= AD_PACKET_SIZE;
+        DebugPrintf(2, ".");
+    }
+    if (bytes > 0)
+    {
+        AnalogDevicesFormPacket(IspEnvironment, 'W', bytes, address, prog_data, &packet);
+        AnalogDevicesSendPacket(IspEnvironment, &packet);
+        DebugPrintf(2, ".");
+    }
+}
+
+/***************************** AnalogDevicesDownload ********************/
+/**  Perform the download into an Analog Devices micro.  As a quick and
+* dirty hack against flash relocations at 0x80000
+* \return 0 if ok, error code else
+* \ToDo: possible to implement the return value instead of calling
+* exit() in sub-functions
+*/
+int AnalogDevicesDownload(ISP_ENVIRONMENT *IspEnvironment)
+{
+    AnalogDevicesSync(IspEnvironment);
+    AnalogDevicesErase(IspEnvironment);
+    if (IspEnvironment->BinaryLength > 0x80000)
+    {
+        DebugPrintf(2, "Note:  Flash remapped 0x80000 to 0.\n");
+        AnalogDevicesWrite(IspEnvironment, IspEnvironment->BinaryContent + 0x80000, 0, IspEnvironment->BinaryLength-0x80000);
+    }
+    else
+    {
+        AnalogDevicesWrite(IspEnvironment, IspEnvironment->BinaryContent, 0, IspEnvironment->BinaryLength);
+    }
+    return (0);
+}
+#endif // AD_SUPPORT
diff --git a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/adprog.h b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/adprog.h
index 484b07b..1cee9e6 100644
--- a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/adprog.h
+++ b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/adprog.h
@@ -1,46 +1,46 @@
-/******************************************************************************
-
-Project:           Portable command line ISP for Philips LPC2000 family
-                   and Analog Devices ADUC70xx
-
-Filename:          adprog.h
-
-Compiler:          Microsoft VC 6/7, GCC Cygwin, GCC Linux, GCC ARM ELF
-
-Author:            Martin Maurer (Martin.Maurer@clibb.de)
-
-Copyright:         (c) Martin Maurer 2003-2008, All rights reserved
-Portions Copyright (c) by Aeolus Development 2004 http://www.aeolusdevelopment.com
-
-    This file is part of lpc21isp.
-
-    lpc21isp is free software: you can redistribute it and/or modify
-    it under the terms of the GNU Lesser General Public License as published by
-    the Free Software Foundation, either version 3 of the License, or
-    any later version.
-
-    lpc21isp is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU Lesser General Public License for more details.
-
-    You should have received a copy of the GNU Lesser General Public License
-    and GNU General Public License along with lpc21isp.
-    If not, see <http://www.gnu.org/licenses/>.
-*/
-
-#define ANALOG_DEVICES_SYNC_CHAR                ((BINARY)0x08)
-#define ANALOG_DEVICES_SYNC_RESPONSE        ("ADuC")
-#define ANALOG_DEVICES_SYNC_SIZE                (strlen(ANALOG_DEVICES_SYNC_RESPONSE))
-#define ANALOG_DEVICES_ACK                        0x6
-#define ANALOG_DEVICES_NAK                        0x7
-
-typedef struct
-{
-    BINARY product_id[15];
-    BINARY version[3];
-    BINARY reserved[4];
-    BINARY terminator[2];
-} AD_SYNC_RESPONSE;
-
-int AnalogDevicesDownload(ISP_ENVIRONMENT *IspEnvironment);
+/******************************************************************************
+
+Project:           Portable command line ISP for Philips LPC2000 family
+                   and Analog Devices ADUC70xx
+
+Filename:          adprog.h
+
+Compiler:          Microsoft VC 6/7, GCC Cygwin, GCC Linux, GCC ARM ELF
+
+Author:            Martin Maurer (Martin.Maurer@clibb.de)
+
+Copyright:         (c) Martin Maurer 2003-2008, All rights reserved
+Portions Copyright (c) by Aeolus Development 2004 http://www.aeolusdevelopment.com
+
+    This file is part of lpc21isp.
+
+    lpc21isp is free software: you can redistribute it and/or modify
+    it under the terms of the GNU Lesser General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    any later version.
+
+    lpc21isp is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    and GNU General Public License along with lpc21isp.
+    If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#define ANALOG_DEVICES_SYNC_CHAR                ((BINARY)0x08)
+#define ANALOG_DEVICES_SYNC_RESPONSE        ("ADuC")
+#define ANALOG_DEVICES_SYNC_SIZE                (strlen(ANALOG_DEVICES_SYNC_RESPONSE))
+#define ANALOG_DEVICES_ACK                        0x6
+#define ANALOG_DEVICES_NAK                        0x7
+
+typedef struct
+{
+    BINARY product_id[15];
+    BINARY version[3];
+    BINARY reserved[4];
+    BINARY terminator[2];
+} AD_SYNC_RESPONSE;
+
+int AnalogDevicesDownload(ISP_ENVIRONMENT *IspEnvironment);
diff --git a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/gpl.txt b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/gpl.txt
new file mode 100644
index 0000000..94a9ed0
--- /dev/null
+++ b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/gpl.txt
@@ -0,0 +1,674 @@
+                    GNU GENERAL PUBLIC LICENSE
+                       Version 3, 29 June 2007
+
+ Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+                            Preamble
+
+  The GNU General Public License is a free, copyleft license for
+software and other kinds of works.
+
+  The licenses for most software and other practical works are designed
+to take away your freedom to share and change the works.  By contrast,
+the GNU General Public License is intended to guarantee your freedom to
+share and change all versions of a program--to make sure it remains free
+software for all its users.  We, the Free Software Foundation, use the
+GNU General Public License for most of our software; it applies also to
+any other work released this way by its authors.  You can apply it to
+your programs, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+them if you wish), that you receive source code or can get it if you
+want it, that you can change the software or use pieces of it in new
+free programs, and that you know you can do these things.
+
+  To protect your rights, we need to prevent others from denying you
+these rights or asking you to surrender the rights.  Therefore, you have
+certain responsibilities if you distribute copies of the software, or if
+you modify it: responsibilities to respect the freedom of others.
+
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must pass on to the recipients the same
+freedoms that you received.  You must make sure that they, too, receive
+or can get the source code.  And you must show them these terms so they
+know their rights.
+
+  Developers that use the GNU GPL protect your rights with two steps:
+(1) assert copyright on the software, and (2) offer you this License
+giving you legal permission to copy, distribute and/or modify it.
+
+  For the developers' and authors' protection, the GPL clearly explains
+that there is no warranty for this free software.  For both users' and
+authors' sake, the GPL requires that modified versions be marked as
+changed, so that their problems will not be attributed erroneously to
+authors of previous versions.
+
+  Some devices are designed to deny users access to install or run
+modified versions of the software inside them, although the manufacturer
+can do so.  This is fundamentally incompatible with the aim of
+protecting users' freedom to change the software.  The systematic
+pattern of such abuse occurs in the area of products for individuals to
+use, which is precisely where it is most unacceptable.  Therefore, we
+have designed this version of the GPL to prohibit the practice for those
+products.  If such problems arise substantially in other domains, we
+stand ready to extend this provision to those domains in future versions
+of the GPL, as needed to protect the freedom of users.
+
+  Finally, every program is threatened constantly by software patents.
+States should not allow patents to restrict development and use of
+software on general-purpose computers, but in those that do, we wish to
+avoid the special danger that patents applied to a free program could
+make it effectively proprietary.  To prevent this, the GPL assures that
+patents cannot be used to render the program non-free.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.
+
+                       TERMS AND CONDITIONS
+
+  0. Definitions.
+
+  "This License" refers to version 3 of the GNU General Public License.
+
+  "Copyright" also means copyright-like laws that apply to other kinds of
+works, such as semiconductor masks.
+
+  "The Program" refers to any copyrightable work licensed under this
+License.  Each licensee is addressed as "you".  "Licensees" and
+"recipients" may be individuals or organizations.
+
+  To "modify" a work means to copy from or adapt all or part of the work
+in a fashion requiring copyright permission, other than the making of an
+exact copy.  The resulting work is called a "modified version" of the
+earlier work or a work "based on" the earlier work.
+
+  A "covered work" means either the unmodified Program or a work based
+on the Program.
+
+  To "propagate" a work means to do anything with it that, without
+permission, would make you directly or secondarily liable for
+infringement under applicable copyright law, except executing it on a
+computer or modifying a private copy.  Propagation includes copying,
+distribution (with or without modification), making available to the
+public, and in some countries other activities as well.
+
+  To "convey" a work means any kind of propagation that enables other
+parties to make or receive copies.  Mere interaction with a user through
+a computer network, with no transfer of a copy, is not conveying.
+
+  An interactive user interface displays "Appropriate Legal Notices"
+to the extent that it includes a convenient and prominently visible
+feature that (1) displays an appropriate copyright notice, and (2)
+tells the user that there is no warranty for the work (except to the
+extent that warranties are provided), that licensees may convey the
+work under this License, and how to view a copy of this License.  If
+the interface presents a list of user commands or options, such as a
+menu, a prominent item in the list meets this criterion.
+
+  1. Source Code.
+
+  The "source code" for a work means the preferred form of the work
+for making modifications to it.  "Object code" means any non-source
+form of a work.
+
+  A "Standard Interface" means an interface that either is an official
+standard defined by a recognized standards body, or, in the case of
+interfaces specified for a particular programming language, one that
+is widely used among developers working in that language.
+
+  The "System Libraries" of an executable work include anything, other
+than the work as a whole, that (a) is included in the normal form of
+packaging a Major Component, but which is not part of that Major
+Component, and (b) serves only to enable use of the work with that
+Major Component, or to implement a Standard Interface for which an
+implementation is available to the public in source code form.  A
+"Major Component", in this context, means a major essential component
+(kernel, window system, and so on) of the specific operating system
+(if any) on which the executable work runs, or a compiler used to
+produce the work, or an object code interpreter used to run it.
+
+  The "Corresponding Source" for a work in object code form means all
+the source code needed to generate, install, and (for an executable
+work) run the object code and to modify the work, including scripts to
+control those activities.  However, it does not include the work's
+System Libraries, or general-purpose tools or generally available free
+programs which are used unmodified in performing those activities but
+which are not part of the work.  For example, Corresponding Source
+includes interface definition files associated with source files for
+the work, and the source code for shared libraries and dynamically
+linked subprograms that the work is specifically designed to require,
+such as by intimate data communication or control flow between those
+subprograms and other parts of the work.
+
+  The Corresponding Source need not include anything that users
+can regenerate automatically from other parts of the Corresponding
+Source.
+
+  The Corresponding Source for a work in source code form is that
+same work.
+
+  2. Basic Permissions.
+
+  All rights granted under this License are granted for the term of
+copyright on the Program, and are irrevocable provided the stated
+conditions are met.  This License explicitly affirms your unlimited
+permission to run the unmodified Program.  The output from running a
+covered work is covered by this License only if the output, given its
+content, constitutes a covered work.  This License acknowledges your
+rights of fair use or other equivalent, as provided by copyright law.
+
+  You may make, run and propagate covered works that you do not
+convey, without conditions so long as your license otherwise remains
+in force.  You may convey covered works to others for the sole purpose
+of having them make modifications exclusively for you, or provide you
+with facilities for running those works, provided that you comply with
+the terms of this License in conveying all material for which you do
+not control copyright.  Those thus making or running the covered works
+for you must do so exclusively on your behalf, under your direction
+and control, on terms that prohibit them from making any copies of
+your copyrighted material outside their relationship with you.
+
+  Conveying under any other circumstances is permitted solely under
+the conditions stated below.  Sublicensing is not allowed; section 10
+makes it unnecessary.
+
+  3. Protecting Users' Legal Rights From Anti-Circumvention Law.
+
+  No covered work shall be deemed part of an effective technological
+measure under any applicable law fulfilling obligations under article
+11 of the WIPO copyright treaty adopted on 20 December 1996, or
+similar laws prohibiting or restricting circumvention of such
+measures.
+
+  When you convey a covered work, you waive any legal power to forbid
+circumvention of technological measures to the extent such circumvention
+is effected by exercising rights under this License with respect to
+the covered work, and you disclaim any intention to limit operation or
+modification of the work as a means of enforcing, against the work's
+users, your or third parties' legal rights to forbid circumvention of
+technological measures.
+
+  4. Conveying Verbatim Copies.
+
+  You may convey verbatim copies of the Program's source code as you
+receive it, in any medium, provided that you conspicuously and
+appropriately publish on each copy an appropriate copyright notice;
+keep intact all notices stating that this License and any
+non-permissive terms added in accord with section 7 apply to the code;
+keep intact all notices of the absence of any warranty; and give all
+recipients a copy of this License along with the Program.
+
+  You may charge any price or no price for each copy that you convey,
+and you may offer support or warranty protection for a fee.
+
+  5. Conveying Modified Source Versions.
+
+  You may convey a work based on the Program, or the modifications to
+produce it from the Program, in the form of source code under the
+terms of section 4, provided that you also meet all of these conditions:
+
+    a) The work must carry prominent notices stating that you modified
+    it, and giving a relevant date.
+
+    b) The work must carry prominent notices stating that it is
+    released under this License and any conditions added under section
+    7.  This requirement modifies the requirement in section 4 to
+    "keep intact all notices".
+
+    c) You must license the entire work, as a whole, under this
+    License to anyone who comes into possession of a copy.  This
+    License will therefore apply, along with any applicable section 7
+    additional terms, to the whole of the work, and all its parts,
+    regardless of how they are packaged.  This License gives no
+    permission to license the work in any other way, but it does not
+    invalidate such permission if you have separately received it.
+
+    d) If the work has interactive user interfaces, each must display
+    Appropriate Legal Notices; however, if the Program has interactive
+    interfaces that do not display Appropriate Legal Notices, your
+    work need not make them do so.
+
+  A compilation of a covered work with other separate and independent
+works, which are not by their nature extensions of the covered work,
+and which are not combined with it such as to form a larger program,
+in or on a volume of a storage or distribution medium, is called an
+"aggregate" if the compilation and its resulting copyright are not
+used to limit the access or legal rights of the compilation's users
+beyond what the individual works permit.  Inclusion of a covered work
+in an aggregate does not cause this License to apply to the other
+parts of the aggregate.
+
+  6. Conveying Non-Source Forms.
+
+  You may convey a covered work in object code form under the terms
+of sections 4 and 5, provided that you also convey the
+machine-readable Corresponding Source under the terms of this License,
+in one of these ways:
+
+    a) Convey the object code in, or embodied in, a physical product
+    (including a physical distribution medium), accompanied by the
+    Corresponding Source fixed on a durable physical medium
+    customarily used for software interchange.
+
+    b) Convey the object code in, or embodied in, a physical product
+    (including a physical distribution medium), accompanied by a
+    written offer, valid for at least three years and valid for as
+    long as you offer spare parts or customer support for that product
+    model, to give anyone who possesses the object code either (1) a
+    copy of the Corresponding Source for all the software in the
+    product that is covered by this License, on a durable physical
+    medium customarily used for software interchange, for a price no
+    more than your reasonable cost of physically performing this
+    conveying of source, or (2) access to copy the
+    Corresponding Source from a network server at no charge.
+
+    c) Convey individual copies of the object code with a copy of the
+    written offer to provide the Corresponding Source.  This
+    alternative is allowed only occasionally and noncommercially, and
+    only if you received the object code with such an offer, in accord
+    with subsection 6b.
+
+    d) Convey the object code by offering access from a designated
+    place (gratis or for a charge), and offer equivalent access to the
+    Corresponding Source in the same way through the same place at no
+    further charge.  You need not require recipients to copy the
+    Corresponding Source along with the object code.  If the place to
+    copy the object code is a network server, the Corresponding Source
+    may be on a different server (operated by you or a third party)
+    that supports equivalent copying facilities, provided you maintain
+    clear directions next to the object code saying where to find the
+    Corresponding Source.  Regardless of what server hosts the
+    Corresponding Source, you remain obligated to ensure that it is
+    available for as long as needed to satisfy these requirements.
+
+    e) Convey the object code using peer-to-peer transmission, provided
+    you inform other peers where the object code and Corresponding
+    Source of the work are being offered to the general public at no
+    charge under subsection 6d.
+
+  A separable portion of the object code, whose source code is excluded
+from the Corresponding Source as a System Library, need not be
+included in conveying the object code work.
+
+  A "User Product" is either (1) a "consumer product", which means any
+tangible personal property which is normally used for personal, family,
+or household purposes, or (2) anything designed or sold for incorporation
+into a dwelling.  In determining whether a product is a consumer product,
+doubtful cases shall be resolved in favor of coverage.  For a particular
+product received by a particular user, "normally used" refers to a
+typical or common use of that class of product, regardless of the status
+of the particular user or of the way in which the particular user
+actually uses, or expects or is expected to use, the product.  A product
+is a consumer product regardless of whether the product has substantial
+commercial, industrial or non-consumer uses, unless such uses represent
+the only significant mode of use of the product.
+
+  "Installation Information" for a User Product means any methods,
+procedures, authorization keys, or other information required to install
+and execute modified versions of a covered work in that User Product from
+a modified version of its Corresponding Source.  The information must
+suffice to ensure that the continued functioning of the modified object
+code is in no case prevented or interfered with solely because
+modification has been made.
+
+  If you convey an object code work under this section in, or with, or
+specifically for use in, a User Product, and the conveying occurs as
+part of a transaction in which the right of possession and use of the
+User Product is transferred to the recipient in perpetuity or for a
+fixed term (regardless of how the transaction is characterized), the
+Corresponding Source conveyed under this section must be accompanied
+by the Installation Information.  But this requirement does not apply
+if neither you nor any third party retains the ability to install
+modified object code on the User Product (for example, the work has
+been installed in ROM).
+
+  The requirement to provide Installation Information does not include a
+requirement to continue to provide support service, warranty, or updates
+for a work that has been modified or installed by the recipient, or for
+the User Product in which it has been modified or installed.  Access to a
+network may be denied when the modification itself materially and
+adversely affects the operation of the network or violates the rules and
+protocols for communication across the network.
+
+  Corresponding Source conveyed, and Installation Information provided,
+in accord with this section must be in a format that is publicly
+documented (and with an implementation available to the public in
+source code form), and must require no special password or key for
+unpacking, reading or copying.
+
+  7. Additional Terms.
+
+  "Additional permissions" are terms that supplement the terms of this
+License by making exceptions from one or more of its conditions.
+Additional permissions that are applicable to the entire Program shall
+be treated as though they were included in this License, to the extent
+that they are valid under applicable law.  If additional permissions
+apply only to part of the Program, that part may be used separately
+under those permissions, but the entire Program remains governed by
+this License without regard to the additional permissions.
+
+  When you convey a copy of a covered work, you may at your option
+remove any additional permissions from that copy, or from any part of
+it.  (Additional permissions may be written to require their own
+removal in certain cases when you modify the work.)  You may place
+additional permissions on material, added by you to a covered work,
+for which you have or can give appropriate copyright permission.
+
+  Notwithstanding any other provision of this License, for material you
+add to a covered work, you may (if authorized by the copyright holders of
+that material) supplement the terms of this License with terms:
+
+    a) Disclaiming warranty or limiting liability differently from the
+    terms of sections 15 and 16 of this License; or
+
+    b) Requiring preservation of specified reasonable legal notices or
+    author attributions in that material or in the Appropriate Legal
+    Notices displayed by works containing it; or
+
+    c) Prohibiting misrepresentation of the origin of that material, or
+    requiring that modified versions of such material be marked in
+    reasonable ways as different from the original version; or
+
+    d) Limiting the use for publicity purposes of names of licensors or
+    authors of the material; or
+
+    e) Declining to grant rights under trademark law for use of some
+    trade names, trademarks, or service marks; or
+
+    f) Requiring indemnification of licensors and authors of that
+    material by anyone who conveys the material (or modified versions of
+    it) with contractual assumptions of liability to the recipient, for
+    any liability that these contractual assumptions directly impose on
+    those licensors and authors.
+
+  All other non-permissive additional terms are considered "further
+restrictions" within the meaning of section 10.  If the Program as you
+received it, or any part of it, contains a notice stating that it is
+governed by this License along with a term that is a further
+restriction, you may remove that term.  If a license document contains
+a further restriction but permits relicensing or conveying under this
+License, you may add to a covered work material governed by the terms
+of that license document, provided that the further restriction does
+not survive such relicensing or conveying.
+
+  If you add terms to a covered work in accord with this section, you
+must place, in the relevant source files, a statement of the
+additional terms that apply to those files, or a notice indicating
+where to find the applicable terms.
+
+  Additional terms, permissive or non-permissive, may be stated in the
+form of a separately written license, or stated as exceptions;
+the above requirements apply either way.
+
+  8. Termination.
+
+  You may not propagate or modify a covered work except as expressly
+provided under this License.  Any attempt otherwise to propagate or
+modify it is void, and will automatically terminate your rights under
+this License (including any patent licenses granted under the third
+paragraph of section 11).
+
+  However, if you cease all violation of this License, then your
+license from a particular copyright holder is reinstated (a)
+provisionally, unless and until the copyright holder explicitly and
+finally terminates your license, and (b) permanently, if the copyright
+holder fails to notify you of the violation by some reasonable means
+prior to 60 days after the cessation.
+
+  Moreover, your license from a particular copyright holder is
+reinstated permanently if the copyright holder notifies you of the
+violation by some reasonable means, this is the first time you have
+received notice of violation of this License (for any work) from that
+copyright holder, and you cure the violation prior to 30 days after
+your receipt of the notice.
+
+  Termination of your rights under this section does not terminate the
+licenses of parties who have received copies or rights from you under
+this License.  If your rights have been terminated and not permanently
+reinstated, you do not qualify to receive new licenses for the same
+material under section 10.
+
+  9. Acceptance Not Required for Having Copies.
+
+  You are not required to accept this License in order to receive or
+run a copy of the Program.  Ancillary propagation of a covered work
+occurring solely as a consequence of using peer-to-peer transmission
+to receive a copy likewise does not require acceptance.  However,
+nothing other than this License grants you permission to propagate or
+modify any covered work.  These actions infringe copyright if you do
+not accept this License.  Therefore, by modifying or propagating a
+covered work, you indicate your acceptance of this License to do so.
+
+  10. Automatic Licensing of Downstream Recipients.
+
+  Each time you convey a covered work, the recipient automatically
+receives a license from the original licensors, to run, modify and
+propagate that work, subject to this License.  You are not responsible
+for enforcing compliance by third parties with this License.
+
+  An "entity transaction" is a transaction transferring control of an
+organization, or substantially all assets of one, or subdividing an
+organization, or merging organizations.  If propagation of a covered
+work results from an entity transaction, each party to that
+transaction who receives a copy of the work also receives whatever
+licenses to the work the party's predecessor in interest had or could
+give under the previous paragraph, plus a right to possession of the
+Corresponding Source of the work from the predecessor in interest, if
+the predecessor has it or can get it with reasonable efforts.
+
+  You may not impose any further restrictions on the exercise of the
+rights granted or affirmed under this License.  For example, you may
+not impose a license fee, royalty, or other charge for exercise of
+rights granted under this License, and you may not initiate litigation
+(including a cross-claim or counterclaim in a lawsuit) alleging that
+any patent claim is infringed by making, using, selling, offering for
+sale, or importing the Program or any portion of it.
+
+  11. Patents.
+
+  A "contributor" is a copyright holder who authorizes use under this
+License of the Program or a work on which the Program is based.  The
+work thus licensed is called the contributor's "contributor version".
+
+  A contributor's "essential patent claims" are all patent claims
+owned or controlled by the contributor, whether already acquired or
+hereafter acquired, that would be infringed by some manner, permitted
+by this License, of making, using, or selling its contributor version,
+but do not include claims that would be infringed only as a
+consequence of further modification of the contributor version.  For
+purposes of this definition, "control" includes the right to grant
+patent sublicenses in a manner consistent with the requirements of
+this License.
+
+  Each contributor grants you a non-exclusive, worldwide, royalty-free
+patent license under the contributor's essential patent claims, to
+make, use, sell, offer for sale, import and otherwise run, modify and
+propagate the contents of its contributor version.
+
+  In the following three paragraphs, a "patent license" is any express
+agreement or commitment, however denominated, not to enforce a patent
+(such as an express permission to practice a patent or covenant not to
+sue for patent infringement).  To "grant" such a patent license to a
+party means to make such an agreement or commitment not to enforce a
+patent against the party.
+
+  If you convey a covered work, knowingly relying on a patent license,
+and the Corresponding Source of the work is not available for anyone
+to copy, free of charge and under the terms of this License, through a
+publicly available network server or other readily accessible means,
+then you must either (1) cause the Corresponding Source to be so
+available, or (2) arrange to deprive yourself of the benefit of the
+patent license for this particular work, or (3) arrange, in a manner
+consistent with the requirements of this License, to extend the patent
+license to downstream recipients.  "Knowingly relying" means you have
+actual knowledge that, but for the patent license, your conveying the
+covered work in a country, or your recipient's use of the covered work
+in a country, would infringe one or more identifiable patents in that
+country that you have reason to believe are valid.
+
+  If, pursuant to or in connection with a single transaction or
+arrangement, you convey, or propagate by procuring conveyance of, a
+covered work, and grant a patent license to some of the parties
+receiving the covered work authorizing them to use, propagate, modify
+or convey a specific copy of the covered work, then the patent license
+you grant is automatically extended to all recipients of the covered
+work and works based on it.
+
+  A patent license is "discriminatory" if it does not include within
+the scope of its coverage, prohibits the exercise of, or is
+conditioned on the non-exercise of one or more of the rights that are
+specifically granted under this License.  You may not convey a covered
+work if you are a party to an arrangement with a third party that is
+in the business of distributing software, under which you make payment
+to the third party based on the extent of your activity of conveying
+the work, and under which the third party grants, to any of the
+parties who would receive the covered work from you, a discriminatory
+patent license (a) in connection with copies of the covered work
+conveyed by you (or copies made from those copies), or (b) primarily
+for and in connection with specific products or compilations that
+contain the covered work, unless you entered into that arrangement,
+or that patent license was granted, prior to 28 March 2007.
+
+  Nothing in this License shall be construed as excluding or limiting
+any implied license or other defenses to infringement that may
+otherwise be available to you under applicable patent law.
+
+  12. No Surrender of Others' Freedom.
+
+  If conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot convey a
+covered work so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you may
+not convey it at all.  For example, if you agree to terms that obligate you
+to collect a royalty for further conveying from those to whom you convey
+the Program, the only way you could satisfy both those terms and this
+License would be to refrain entirely from conveying the Program.
+
+  13. Use with the GNU Affero General Public License.
+
+  Notwithstanding any other provision of this License, you have
+permission to link or combine any covered work with a work licensed
+under version 3 of the GNU Affero General Public License into a single
+combined work, and to convey the resulting work.  The terms of this
+License will continue to apply to the part which is the covered work,
+but the special requirements of the GNU Affero General Public License,
+section 13, concerning interaction through a network will apply to the
+combination as such.
+
+  14. Revised Versions of this License.
+
+  The Free Software Foundation may publish revised and/or new versions of
+the GNU General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+  Each version is given a distinguishing version number.  If the
+Program specifies that a certain numbered version of the GNU General
+Public License "or any later version" applies to it, you have the
+option of following the terms and conditions either of that numbered
+version or of any later version published by the Free Software
+Foundation.  If the Program does not specify a version number of the
+GNU General Public License, you may choose any version ever published
+by the Free Software Foundation.
+
+  If the Program specifies that a proxy can decide which future
+versions of the GNU General Public License can be used, that proxy's
+public statement of acceptance of a version permanently authorizes you
+to choose that version for the Program.
+
+  Later license versions may give you additional or different
+permissions.  However, no additional obligations are imposed on any
+author or copyright holder as a result of your choosing to follow a
+later version.
+
+  15. Disclaimer of Warranty.
+
+  THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
+APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
+HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
+OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
+THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
+IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
+ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+  16. Limitation of Liability.
+
+  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
+THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
+GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
+USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
+DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
+PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
+EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
+SUCH DAMAGES.
+
+  17. Interpretation of Sections 15 and 16.
+
+  If the disclaimer of warranty and limitation of liability provided
+above cannot be given local legal effect according to their terms,
+reviewing courts shall apply local law that most closely approximates
+an absolute waiver of all civil liability in connection with the
+Program, unless a warranty or assumption of liability accompanies a
+copy of the Program in return for a fee.
+
+                     END OF TERMS AND CONDITIONS
+
+            How to Apply These Terms to Your New Programs
+
+  If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+  To do so, attach the following notices to the program.  It is safest
+to attach them to the start of each source file to most effectively
+state the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the program's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This program is free software: you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+Also add information on how to contact you by electronic and paper mail.
+
+  If the program does terminal interaction, make it output a short
+notice like this when it starts in an interactive mode:
+
+    <program>  Copyright (C) <year>  <name of author>
+    This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+    This is free software, and you are welcome to redistribute it
+    under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License.  Of course, your program's commands
+might be different; for a GUI interface, you would use an "about box".
+
+  You should also get your employer (if you work as a programmer) or school,
+if any, to sign a "copyright disclaimer" for the program, if necessary.
+For more information on this, and how to apply and follow the GNU GPL, see
+<http://www.gnu.org/licenses/>.
+
+  The GNU General Public License does not permit incorporating your program
+into proprietary programs.  If your program is a subroutine library, you
+may consider it more useful to permit linking proprietary applications with
+the library.  If this is what you want to do, use the GNU Lesser General
+Public License instead of this License.  But first, please read
+<http://www.gnu.org/philosophy/why-not-lgpl.html>.
diff --git a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lgpl-3.0.txt b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lgpl-3.0.txt
new file mode 100644
index 0000000..fc8a5de
--- /dev/null
+++ b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lgpl-3.0.txt
@@ -0,0 +1,165 @@
+		   GNU LESSER GENERAL PUBLIC LICENSE
+                       Version 3, 29 June 2007
+
+ Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+
+  This version of the GNU Lesser General Public License incorporates
+the terms and conditions of version 3 of the GNU General Public
+License, supplemented by the additional permissions listed below.
+
+  0. Additional Definitions. 
+
+  As used herein, "this License" refers to version 3 of the GNU Lesser
+General Public License, and the "GNU GPL" refers to version 3 of the GNU
+General Public License.
+
+  "The Library" refers to a covered work governed by this License,
+other than an Application or a Combined Work as defined below.
+
+  An "Application" is any work that makes use of an interface provided
+by the Library, but which is not otherwise based on the Library.
+Defining a subclass of a class defined by the Library is deemed a mode
+of using an interface provided by the Library.
+
+  A "Combined Work" is a work produced by combining or linking an
+Application with the Library.  The particular version of the Library
+with which the Combined Work was made is also called the "Linked
+Version".
+
+  The "Minimal Corresponding Source" for a Combined Work means the
+Corresponding Source for the Combined Work, excluding any source code
+for portions of the Combined Work that, considered in isolation, are
+based on the Application, and not on the Linked Version.
+
+  The "Corresponding Application Code" for a Combined Work means the
+object code and/or source code for the Application, including any data
+and utility programs needed for reproducing the Combined Work from the
+Application, but excluding the System Libraries of the Combined Work.
+
+  1. Exception to Section 3 of the GNU GPL.
+
+  You may convey a covered work under sections 3 and 4 of this License
+without being bound by section 3 of the GNU GPL.
+
+  2. Conveying Modified Versions.
+
+  If you modify a copy of the Library, and, in your modifications, a
+facility refers to a function or data to be supplied by an Application
+that uses the facility (other than as an argument passed when the
+facility is invoked), then you may convey a copy of the modified
+version:
+
+   a) under this License, provided that you make a good faith effort to
+   ensure that, in the event an Application does not supply the
+   function or data, the facility still operates, and performs
+   whatever part of its purpose remains meaningful, or
+
+   b) under the GNU GPL, with none of the additional permissions of
+   this License applicable to that copy.
+
+  3. Object Code Incorporating Material from Library Header Files.
+
+  The object code form of an Application may incorporate material from
+a header file that is part of the Library.  You may convey such object
+code under terms of your choice, provided that, if the incorporated
+material is not limited to numerical parameters, data structure
+layouts and accessors, or small macros, inline functions and templates
+(ten or fewer lines in length), you do both of the following:
+
+   a) Give prominent notice with each copy of the object code that the
+   Library is used in it and that the Library and its use are
+   covered by this License.
+
+   b) Accompany the object code with a copy of the GNU GPL and this license
+   document.
+
+  4. Combined Works.
+
+  You may convey a Combined Work under terms of your choice that,
+taken together, effectively do not restrict modification of the
+portions of the Library contained in the Combined Work and reverse
+engineering for debugging such modifications, if you also do each of
+the following:
+
+   a) Give prominent notice with each copy of the Combined Work that
+   the Library is used in it and that the Library and its use are
+   covered by this License.
+
+   b) Accompany the Combined Work with a copy of the GNU GPL and this license
+   document.
+
+   c) For a Combined Work that displays copyright notices during
+   execution, include the copyright notice for the Library among
+   these notices, as well as a reference directing the user to the
+   copies of the GNU GPL and this license document.
+
+   d) Do one of the following:
+
+       0) Convey the Minimal Corresponding Source under the terms of this
+       License, and the Corresponding Application Code in a form
+       suitable for, and under terms that permit, the user to
+       recombine or relink the Application with a modified version of
+       the Linked Version to produce a modified Combined Work, in the
+       manner specified by section 6 of the GNU GPL for conveying
+       Corresponding Source.
+
+       1) Use a suitable shared library mechanism for linking with the
+       Library.  A suitable mechanism is one that (a) uses at run time
+       a copy of the Library already present on the user's computer
+       system, and (b) will operate properly with a modified version
+       of the Library that is interface-compatible with the Linked
+       Version. 
+
+   e) Provide Installation Information, but only if you would otherwise
+   be required to provide such information under section 6 of the
+   GNU GPL, and only to the extent that such information is
+   necessary to install and execute a modified version of the
+   Combined Work produced by recombining or relinking the
+   Application with a modified version of the Linked Version. (If
+   you use option 4d0, the Installation Information must accompany
+   the Minimal Corresponding Source and Corresponding Application
+   Code. If you use option 4d1, you must provide the Installation
+   Information in the manner specified by section 6 of the GNU GPL
+   for conveying Corresponding Source.)
+
+  5. Combined Libraries.
+
+  You may place library facilities that are a work based on the
+Library side by side in a single library together with other library
+facilities that are not Applications and are not covered by this
+License, and convey such a combined library under terms of your
+choice, if you do both of the following:
+
+   a) Accompany the combined library with a copy of the same work based
+   on the Library, uncombined with any other library facilities,
+   conveyed under the terms of this License.
+
+   b) Give prominent notice with the combined library that part of it
+   is a work based on the Library, and explaining where to find the
+   accompanying uncombined form of the same work.
+
+  6. Revised Versions of the GNU Lesser General Public License.
+
+  The Free Software Foundation may publish revised and/or new versions
+of the GNU Lesser General Public License from time to time. Such new
+versions will be similar in spirit to the present version, but may
+differ in detail to address new problems or concerns.
+
+  Each version is given a distinguishing version number. If the
+Library as you received it specifies that a certain numbered version
+of the GNU Lesser General Public License "or any later version"
+applies to it, you have the option of following the terms and
+conditions either of that published version or of any later version
+published by the Free Software Foundation. If the Library as you
+received it does not specify a version number of the GNU Lesser
+General Public License, you may choose any version of the GNU Lesser
+General Public License ever published by the Free Software Foundation.
+
+  If the Library as you received it specifies that a proxy can decide
+whether future versions of the GNU Lesser General Public License shall
+apply, that proxy's public statement of acceptance of any version is
+permanent authorization for you to choose that version for the
+Library.
diff --git a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpc21isp.c b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpc21isp.c
index 4c48645..e5aa115 100644
--- a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpc21isp.c
+++ b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpc21isp.c
@@ -1,15 +1,16 @@
 /******************************************************************************
 
-Project:           Portable command line ISP for Philips LPC17XX / LPC2000 family
+Project:           Portable command line ISP for NXP LPC1000 / LPC2000 family
                    and Analog Devices ADUC70xx
 
 Filename:          lpc21isp.c
 
-Compiler:          Microsoft VC 6/7, Microsoft VS2008, GCC Cygwin, GCC Linux, GCC ARM ELF
+Compiler:          Microsoft VC 6/7, Microsoft VS2008, Microsoft VS2010,
+                   GCC Cygwin, GCC Linux, GCC ARM ELF
 
 Author:            Martin Maurer (Martin.Maurer@clibb.de)
 
-Copyright:         (c) Martin Maurer 2003-2010, All rights reserved
+Copyright:         (c) Martin Maurer 2003-2011, All rights reserved
 Portions Copyright (c) by Aeolus Development 2004 http://www.aeolusdevelopment.com
 
     This file is part of lpc21isp.
@@ -316,13 +317,23 @@ Change-History:
                   Added -Wall to Makefile to report warnings more comprehensively
                   Added #define in lpc21isp.h to substitute strnicmp with strncasecmp (needed for Unix)
                   Fixed a few format specifiers in lpcprog.c to eliminate some warnings
-
+1.80   2010-03-04 Philip Munts
+                  Added entries to LPCtypes[] in lpcprog.c for obsolete revisions of LPC2364/6/8/78.
+                  Added entry to LPCtypes[] in lpcprog.c for new LPC2387.
+1.81   2011-03-14 Martin Maurer
+                  Added chip id for LPC1102
+                  Thanks to Conurus for detecting and fixing a bug with patching checksum
+                  (patching was too early, chip id was not yet available)
+                  (Re-)Added code to start downloaded via "G 0 T", when using LPC1xxx
+                  (Starting code at position 0 seems to work, compare to comment of version 1.70)
+                  Add support for LPC122x (untested, i have not yet such a device)
+                  Add support for LPC177x / LPC178x (untested, i have not yet such a device)
 */
 
 // Please don't use TABs in the source code !!!
 
 // Don't forget to update the version string that is on the next line
-#define VERSION_STR "1.79"
+#define VERSION_STR "1.81"
 
 #if defined COMPILE_FOR_WINDOWS || defined COMPILE_FOR_CYGWIN
 static char RxTmpBuf[256];        // save received data to this buffer for half-duplex
@@ -489,6 +500,10 @@ static void OpenSerialPort(ISP_ENVIRONMENT *IspEnvironment)
 #ifdef B9600
           case    9600: NEWTERMIOS_SETBAUDARTE(B9600); break;
 #endif // B9600
+
+          // Special value
+          case   32000: NEWTERMIOS_SETBAUDARTE(32000); break;
+
           default:
               {
                   DebugPrintf(1, "unknown baudrate %s\n", IspEnvironment->baud_rate);
diff --git a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpc21isp.h b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpc21isp.h
index 1bec44d..c9b9320 100644
--- a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpc21isp.h
+++ b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpc21isp.h
@@ -1,288 +1,288 @@
-/******************************************************************************
-
-Project:           Portable command line ISP for Philips LPC2000 family
-                   and Analog Devices ADUC70xx
-
-Filename:          lsp21isp.h
-
-Compiler:          Microsoft VC 6/7, GCC Cygwin, GCC Linux, GCC ARM ELF
-
-Author:            Martin Maurer (Martin.Maurer@clibb.de)
-
-Copyright:         (c) Martin Maurer 2003-2008, All rights reserved
-Portions Copyright (c) by Aeolus Development 2004 http://www.aeolusdevelopment.com
-
-    This file is part of lpc21isp.
-
-    lpc21isp is free software: you can redistribute it and/or modify
-    it under the terms of the GNU Lesser General Public License as published by
-    the Free Software Foundation, either version 3 of the License, or
-    any later version.
-
-    lpc21isp is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU Lesser General Public License for more details.
-
-    You should have received a copy of the GNU Lesser General Public License
-    and GNU General Public License along with lpc21isp.
-    If not, see <http://www.gnu.org/licenses/>.
-*/
-
-// #define INTEGRATED_IN_WIN_APP
-
-#if defined(_WIN32) && !defined(__CYGWIN__)
-#define COMPILE_FOR_WINDOWS
-#define COMPILED_FOR "Windows"
-#elif defined(__CYGWIN__)
-#define COMPILE_FOR_CYGWIN
-#define COMPILED_FOR "Cygwin"
-#elif defined(__arm__) || defined(__thumb__)
-#define COMPILE_FOR_LPC21
-#define COMPILED_FOR "ARM"
-#define printf iprintf
-#elif defined(__APPLE__)
-#define COMPILE_FOR_LINUX
-#define COMPILED_FOR "Apple MacOS X"
-#elif defined(__FreeBSD__)
-#define COMPILE_FOR_LINUX
-#define COMPILED_FOR "FreeBSD"
-#elif defined(__OpenBSD__)
-#define COMPILE_FOR_LINUX
-#define COMPILED_FOR "OpenBSD"
-#else
-#define COMPILE_FOR_LINUX
-#define COMPILED_FOR "Linux"
-#endif
-
-// The Required features can be enabled / disabled here
-#define LPC_SUPPORT
-
-#ifndef COMPILE_FOR_LPC21
-#define AD_SUPPORT
-#define TERMINAL_SUPPORT
-#endif
-
-#if defined COMPILE_FOR_WINDOWS || defined COMPILE_FOR_CYGWIN
-#include <windows.h>
-#include <io.h>
-#endif // defined COMPILE_FOR_WINDOWS || defined COMPILE_FOR_CYGWIN
-
-#if defined COMPILE_FOR_WINDOWS
-#include <conio.h>
-//#define TRACE(x) OutputDebugString(x)
-#define TRACE(x) printf("%s",x)
-#endif // defined COMPILE_FOR_WINDOWS
-
-#if defined COMPILE_FOR_CYGWIN
-//#define TRACE(x) OutputDebugString(x)
-#define TRACE(x) printf("%s",x)
-#endif // defined COMPILE_FOR_WINDOWS
-
-#if defined COMPILE_FOR_LINUX
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <stdlib.h>
-#include <string.h>
-#include <strings.h>
-#include <sys/ioctl.h>
-extern void Sleep(unsigned long MilliSeconds);
-#define TRACE(x) printf("%s",x)
-#endif // defined COMPILE_FOR_LINUX
-
-#if defined COMPILE_FOR_LINUX || defined COMPILE_FOR_CYGWIN
-#include <termios.h>
-#include <unistd.h>     // for read and return value of lseek
-#include <sys/time.h>   // for select_time
-extern int kbhit(void);
-extern int getch(void);
-extern struct termios keyboard_origtty;
-#endif // defined COMPILE_FOR_LINUX || defined COMPILE_FOR_CYGWIN
-
-#include <ctype.h>      // isdigit()
-#include <stdio.h>      // stdout
-#include <stdarg.h>
-#include <time.h>
-#if defined (COMPILE_FOR_LINUX)
-#if defined(__OpenBSD__)
-#include <errno.h>
-#else
-#include <sys/errno.h>
-#endif
-#endif
-
-#if defined COMPILE_FOR_LPC21
-#include <stdlib.h>
-#include <string.h>
-//#include <lpc_ioctl.h>  // if using libc serial port communication
-#else
-#include <fcntl.h>
-#endif
-
-typedef enum
-{
-    PHILIPS_ARM,
-    ANALOG_DEVICES_ARM
-} TARGET;
-
-typedef enum
-{
-    PROGRAM_MODE,
-    RUN_MODE
-} TARGET_MODE;
-
-typedef enum
-{
-    FORMAT_BINARY,
-    FORMAT_HEX
-} FILE_FORMAT_TYPE;
-
-typedef unsigned char BINARY;               // Data type used for microcontroller
-
-/** Used to create list of files to read in. */
-typedef struct file_list FILE_LIST;
-
-/** Structure used to build list of input files. */
-struct file_list
-{
-    const char *name;       /**< The name of the input file.	*/
-    FILE_LIST *prev;        /**< The previous file name in the list.*/
-    char hex_flag;          /**< True if the input file is hex.	*/
-};
-
-typedef struct
-{
-#if !defined COMPILE_FOR_LPC21
-    TARGET micro;                                // The type of micro that will be programmed.
-    FILE_FORMAT_TYPE FileFormat;
-    unsigned char ProgramChip;                // Normally set
-
-    unsigned char ControlLines;
-    unsigned char ControlLinesSwapped;
-    unsigned char ControlLinesInverted;
-    unsigned char LogFile;
-    FILE_LIST *f_list;                  // List of files to read in.
-    int nQuestionMarks; // how many times to try to synchronise
-    int DoNotStart;
-    char *serial_port;                  // Name of the serial port to use to
-                                        // communicate with the microcontroller.
-                                        // Read from the command line.
-#endif // !defined COMPILE_FOR_LPC21
-
-    unsigned char TerminalOnly;         // Declared here for lazyness saves ifdef's
-#ifdef TERMINAL_SUPPORT
-    unsigned char TerminalAfterUpload;
-    unsigned char LocalEcho;
-#endif
-
-    unsigned char HalfDuplex;           // Only used for LPC Programming
-    unsigned char DetectOnly;
-    unsigned char WipeDevice;
-    unsigned char Verify;
-    int           DetectedDevice;       /* index in LPCtypes[] array */
-    char *baud_rate;                    /**< Baud rate to use on the serial
-                                           * port communicating with the
-                                           * microcontroller. Read from the
-                                           * command line.                        */
-
-    char StringOscillator[6];           /**< Holds representation of oscillator
-                                           * speed from the command line.         */
-
-    BINARY *FileContent;
-    BINARY *BinaryContent;              /**< Binary image of the                  */
-                                          /* microcontroller's memory.            */
-    unsigned long BinaryLength;
-    unsigned long BinaryOffset;
-    unsigned long StartAddress;
-    unsigned long BinaryMemSize;
-
-#if defined COMPILE_FOR_WINDOWS || defined COMPILE_FOR_CYGWIN
-    HANDLE hCom;
-#endif // defined COMPILE_FOR_WINDOWS || defined COMPILE_FOR_CYGWIN
-
-#if defined COMPILE_FOR_LINUX || defined COMPILE_FOR_LPC21
-    int fdCom;
-#endif // defined COMPILE_FOR_LINUX || defined COMPILE_FOR_LPC21
-
-#if defined COMPILE_FOR_LINUX
-    struct termios oldtio, newtio;
-#endif // defined COMPILE_FOR_LINUX
-
-#ifdef INTEGRATED_IN_WIN_APP
-    unsigned char NoSync;
-#endif
-
-    unsigned serial_timeout_count;   /**< Local used to track timeouts on serial port read. */
-
-} ISP_ENVIRONMENT;
-
-#if defined COMPILE_FOR_LPC21
-
-#define DebugPrintf(in, ...)
-
-#else
-extern int debug_level;
-
-#if defined INTEGRATED_IN_WIN_APP
-
-#define DebugPrintf AppDebugPrintf
-void AppDebugPrintf(int level, const char *fmt, ...);
-
-#define exit(val)   AppException(val)
-void AppException(int exception_level);
-
-int AppDoProgram(int argc, char *argv[]);
-
-#define Exclude_kbhit 1
-int AppSyncing(int trials);
-void AppWritten(int size);
-
-#else
-void DebugPrintf(int level, const char *fmt, ...);
-//#define DebugPrintf(level, ...) if (level <= debug_level) { TRACE( __VA_ARGS__ ); }
-#endif
-
-void ClearSerialPortBuffers(ISP_ENVIRONMENT *IspEnvironment);
-
-#endif
-
-
-#if defined COMPILE_FOR_LINUX
-#define stricmp strcasecmp
-#define strnicmp strncasecmp
-#endif // defined COMPILE_FOR_LINUX
-
-#ifndef O_BINARY
-#define O_BINARY 0
-#endif // O_BINARY
-
-#ifndef DWORD
-#define DWORD unsigned long
-#endif // DWORD
-
-/*
-debug levels
-0 - very quiet          - Nothing gets printed at this level
-1 - quiet               - Only error messages should be printed
-2 - indicate progress   - Add progress messages
-3 - first level debug   - Major level tracing
-4 - second level debug  - Add detailed debugging
-5 - log comm's          - log serial I/O
-*/
-
-
-void ReceiveComPort(ISP_ENVIRONMENT *IspEnvironment,
-                    const char *Ans, unsigned long MaxSize,
-                    unsigned long *RealSize, unsigned long WantedNr0x0A,
-                    unsigned timeOutMilliseconds);
-void PrepareKeyboardTtySettings(void);
-void ResetKeyboardTtySettings(void);
-void ResetTarget(ISP_ENVIRONMENT *IspEnvironment, TARGET_MODE mode);
-
-void DumpString(int level, const void *s, size_t size, const char *prefix_string);
-void SendComPort(ISP_ENVIRONMENT *IspEnvironment, const char *s);
-void SendComPortBlock(ISP_ENVIRONMENT *IspEnvironment, const void *s, size_t n);
-int ReceiveComPortBlockComplete(ISP_ENVIRONMENT *IspEnvironment, void *block, size_t size, unsigned timeout);
-void ClearSerialPortBuffers(ISP_ENVIRONMENT *IspEnvironment);
-
-int lpctest(char* FileName);
+/******************************************************************************
+
+Project:           Portable command line ISP for Philips LPC2000 family
+                   and Analog Devices ADUC70xx
+
+Filename:          lsp21isp.h
+
+Compiler:          Microsoft VC 6/7, GCC Cygwin, GCC Linux, GCC ARM ELF
+
+Author:            Martin Maurer (Martin.Maurer@clibb.de)
+
+Copyright:         (c) Martin Maurer 2003-2008, All rights reserved
+Portions Copyright (c) by Aeolus Development 2004 http://www.aeolusdevelopment.com
+
+    This file is part of lpc21isp.
+
+    lpc21isp is free software: you can redistribute it and/or modify
+    it under the terms of the GNU Lesser General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    any later version.
+
+    lpc21isp is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    and GNU General Public License along with lpc21isp.
+    If not, see <http://www.gnu.org/licenses/>.
+*/
+
+// #define INTEGRATED_IN_WIN_APP
+
+#if defined(_WIN32) && !defined(__CYGWIN__)
+#define COMPILE_FOR_WINDOWS
+#define COMPILED_FOR "Windows"
+#elif defined(__CYGWIN__)
+#define COMPILE_FOR_CYGWIN
+#define COMPILED_FOR "Cygwin"
+#elif defined(__arm__) || defined(__thumb__)
+#define COMPILE_FOR_LPC21
+#define COMPILED_FOR "ARM"
+#define printf iprintf
+#elif defined(__APPLE__)
+#define COMPILE_FOR_LINUX
+#define COMPILED_FOR "Apple MacOS X"
+#elif defined(__FreeBSD__)
+#define COMPILE_FOR_LINUX
+#define COMPILED_FOR "FreeBSD"
+#elif defined(__OpenBSD__)
+#define COMPILE_FOR_LINUX
+#define COMPILED_FOR "OpenBSD"
+#else
+#define COMPILE_FOR_LINUX
+#define COMPILED_FOR "Linux"
+#endif
+
+// The Required features can be enabled / disabled here
+#define LPC_SUPPORT
+
+#ifndef COMPILE_FOR_LPC21
+#define AD_SUPPORT
+#define TERMINAL_SUPPORT
+#endif
+
+#if defined COMPILE_FOR_WINDOWS || defined COMPILE_FOR_CYGWIN
+#include <windows.h>
+#include <io.h>
+#endif // defined COMPILE_FOR_WINDOWS || defined COMPILE_FOR_CYGWIN
+
+#if defined COMPILE_FOR_WINDOWS
+#include <conio.h>
+//#define TRACE(x) OutputDebugString(x)
+#define TRACE(x) printf("%s",x)
+#endif // defined COMPILE_FOR_WINDOWS
+
+#if defined COMPILE_FOR_CYGWIN
+//#define TRACE(x) OutputDebugString(x)
+#define TRACE(x) printf("%s",x)
+#endif // defined COMPILE_FOR_WINDOWS
+
+#if defined COMPILE_FOR_LINUX
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <stdlib.h>
+#include <string.h>
+#include <strings.h>
+#include <sys/ioctl.h>
+extern void Sleep(unsigned long MilliSeconds);
+#define TRACE(x) printf("%s",x)
+#endif // defined COMPILE_FOR_LINUX
+
+#if defined COMPILE_FOR_LINUX || defined COMPILE_FOR_CYGWIN
+#include <termios.h>
+#include <unistd.h>     // for read and return value of lseek
+#include <sys/time.h>   // for select_time
+extern int kbhit(void);
+extern int getch(void);
+extern struct termios keyboard_origtty;
+#endif // defined COMPILE_FOR_LINUX || defined COMPILE_FOR_CYGWIN
+
+#include <ctype.h>      // isdigit()
+#include <stdio.h>      // stdout
+#include <stdarg.h>
+#include <time.h>
+#if defined (COMPILE_FOR_LINUX)
+#if defined(__OpenBSD__)
+#include <errno.h>
+#else
+#include <sys/errno.h>
+#endif
+#endif
+
+#if defined COMPILE_FOR_LPC21
+#include <stdlib.h>
+#include <string.h>
+//#include <lpc_ioctl.h>  // if using libc serial port communication
+#else
+#include <fcntl.h>
+#endif
+
+typedef enum
+{
+    PHILIPS_ARM,
+    ANALOG_DEVICES_ARM
+} TARGET;
+
+typedef enum
+{
+    PROGRAM_MODE,
+    RUN_MODE
+} TARGET_MODE;
+
+typedef enum
+{
+    FORMAT_BINARY,
+    FORMAT_HEX
+} FILE_FORMAT_TYPE;
+
+typedef unsigned char BINARY;               // Data type used for microcontroller
+
+/** Used to create list of files to read in. */
+typedef struct file_list FILE_LIST;
+
+/** Structure used to build list of input files. */
+struct file_list
+{
+    const char *name;       /**< The name of the input file.	*/
+    FILE_LIST *prev;        /**< The previous file name in the list.*/
+    char hex_flag;          /**< True if the input file is hex.	*/
+};
+
+typedef struct
+{
+#if !defined COMPILE_FOR_LPC21
+    TARGET micro;                                // The type of micro that will be programmed.
+    FILE_FORMAT_TYPE FileFormat;
+    unsigned char ProgramChip;                // Normally set
+
+    unsigned char ControlLines;
+    unsigned char ControlLinesSwapped;
+    unsigned char ControlLinesInverted;
+    unsigned char LogFile;
+    FILE_LIST *f_list;                  // List of files to read in.
+    int nQuestionMarks; // how many times to try to synchronise
+    int DoNotStart;
+    char *serial_port;                  // Name of the serial port to use to
+                                        // communicate with the microcontroller.
+                                        // Read from the command line.
+#endif // !defined COMPILE_FOR_LPC21
+
+    unsigned char TerminalOnly;         // Declared here for lazyness saves ifdef's
+#ifdef TERMINAL_SUPPORT
+    unsigned char TerminalAfterUpload;
+    unsigned char LocalEcho;
+#endif
+
+    unsigned char HalfDuplex;           // Only used for LPC Programming
+    unsigned char DetectOnly;
+    unsigned char WipeDevice;
+    unsigned char Verify;
+    int           DetectedDevice;       /* index in LPCtypes[] array */
+    char *baud_rate;                    /**< Baud rate to use on the serial
+                                           * port communicating with the
+                                           * microcontroller. Read from the
+                                           * command line.                        */
+
+    char StringOscillator[6];           /**< Holds representation of oscillator
+                                           * speed from the command line.         */
+
+    BINARY *FileContent;
+    BINARY *BinaryContent;              /**< Binary image of the                  */
+                                          /* microcontroller's memory.            */
+    unsigned long BinaryLength;
+    unsigned long BinaryOffset;
+    unsigned long StartAddress;
+    unsigned long BinaryMemSize;
+
+#if defined COMPILE_FOR_WINDOWS || defined COMPILE_FOR_CYGWIN
+    HANDLE hCom;
+#endif // defined COMPILE_FOR_WINDOWS || defined COMPILE_FOR_CYGWIN
+
+#if defined COMPILE_FOR_LINUX || defined COMPILE_FOR_LPC21
+    int fdCom;
+#endif // defined COMPILE_FOR_LINUX || defined COMPILE_FOR_LPC21
+
+#if defined COMPILE_FOR_LINUX
+    struct termios oldtio, newtio;
+#endif // defined COMPILE_FOR_LINUX
+
+#ifdef INTEGRATED_IN_WIN_APP
+    unsigned char NoSync;
+#endif
+
+    unsigned serial_timeout_count;   /**< Local used to track timeouts on serial port read. */
+
+} ISP_ENVIRONMENT;
+
+#if defined COMPILE_FOR_LPC21
+
+#define DebugPrintf(in, ...)
+
+#else
+extern int debug_level;
+
+#if defined INTEGRATED_IN_WIN_APP
+
+#define DebugPrintf AppDebugPrintf
+void AppDebugPrintf(int level, const char *fmt, ...);
+
+#define exit(val)   AppException(val)
+void AppException(int exception_level);
+
+int AppDoProgram(int argc, char *argv[]);
+
+#define Exclude_kbhit 1
+int AppSyncing(int trials);
+void AppWritten(int size);
+
+#else
+void DebugPrintf(int level, const char *fmt, ...);
+//#define DebugPrintf(level, ...) if (level <= debug_level) { TRACE( __VA_ARGS__ ); }
+#endif
+
+void ClearSerialPortBuffers(ISP_ENVIRONMENT *IspEnvironment);
+
+#endif
+
+
+#if defined COMPILE_FOR_LINUX
+#define stricmp strcasecmp
+#define strnicmp strncasecmp
+#endif // defined COMPILE_FOR_LINUX
+
+#ifndef O_BINARY
+#define O_BINARY 0
+#endif // O_BINARY
+
+#ifndef DWORD
+#define DWORD unsigned long
+#endif // DWORD
+
+/*
+debug levels
+0 - very quiet          - Nothing gets printed at this level
+1 - quiet               - Only error messages should be printed
+2 - indicate progress   - Add progress messages
+3 - first level debug   - Major level tracing
+4 - second level debug  - Add detailed debugging
+5 - log comm's          - log serial I/O
+*/
+
+
+void ReceiveComPort(ISP_ENVIRONMENT *IspEnvironment,
+                    const char *Ans, unsigned long MaxSize,
+                    unsigned long *RealSize, unsigned long WantedNr0x0A,
+                    unsigned timeOutMilliseconds);
+void PrepareKeyboardTtySettings(void);
+void ResetKeyboardTtySettings(void);
+void ResetTarget(ISP_ENVIRONMENT *IspEnvironment, TARGET_MODE mode);
+
+void DumpString(int level, const void *s, size_t size, const char *prefix_string);
+void SendComPort(ISP_ENVIRONMENT *IspEnvironment, const char *s);
+void SendComPortBlock(ISP_ENVIRONMENT *IspEnvironment, const void *s, size_t n);
+int ReceiveComPortBlockComplete(ISP_ENVIRONMENT *IspEnvironment, void *block, size_t size, unsigned timeout);
+void ClearSerialPortBuffers(ISP_ENVIRONMENT *IspEnvironment);
+
+int lpctest(char* FileName);
diff --git a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.c b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.c
index ba2d5f4..da71f2a 100644
--- a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.c
+++ b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.c
@@ -94,6 +94,10 @@ static LPC_DEVICE_TYPE LPCtypes[] =
 {
     { 0, 0, 0 },  /* unknown */
 
+    // id, name of product, flash size, ram size, total number of sector, max copy size, sector table, chip variant
+
+    { 0x2500102B, "1102",  32,  8,  8, 4096, SectorTable_17xx, CHIP_VARIANT_LPC11XX },
+
     { 0x041E502B, "1111.../101",   8,  2,  2, 1024, SectorTable_17xx, CHIP_VARIANT_LPC11XX },
     { 0x0416502B, "1111.../201",   8,  4,  2, 2048, SectorTable_17xx, CHIP_VARIANT_LPC11XX },
     { 0x042D502B, "1112.../101",  16,  2,  4, 1024, SectorTable_17xx, CHIP_VARIANT_LPC11XX },
@@ -103,66 +107,88 @@ static LPC_DEVICE_TYPE LPCtypes[] =
     { 0x0444502B, "1114.../201",  32,  4,  8, 2048, SectorTable_17xx, CHIP_VARIANT_LPC11XX },
     { 0x0444102B, "1114.../301",  32,  8,  8, 4096, SectorTable_17xx, CHIP_VARIANT_LPC11XX },
 
-    { 0x2C42502B, "1311",   8,  4,  2, 2048, SectorTable_17xx, CHIP_VARIANT_LPC13XX },
-    { 0x2C40102B, "1313",  32,  8,  8, 4096, SectorTable_17xx, CHIP_VARIANT_LPC13XX },
-    { 0x3D01402B, "1342",   8,  4,  2, 2048, SectorTable_17xx, CHIP_VARIANT_LPC13XX },
-    { 0x3D00002B, "1343",  32,  8,  8, 4096, SectorTable_17xx, CHIP_VARIANT_LPC13XX },
-
-    { 0x25001118, "1751",  32,  8,  8, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
-    { 0x25001121, "1752",  64, 16, 16, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
-    { 0x25011722, "1754", 128, 32, 18, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
-    { 0x25011723, "1756", 256, 32, 22, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
-    { 0x25013F37, "1758", 512, 64, 30, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
-    { 0x25113737, "1759", 512, 64, 30, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
-    { 0x26011922, "1764", 128, 32, 18, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
-    { 0x26013733, "1765", 256, 64, 22, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
-    { 0x26013F33, "1766", 256, 64, 22, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
-    { 0x26012837, "1767", 512, 64, 30, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
-    { 0x26013F37, "1768", 512, 64, 30, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
-    { 0x26113F37, "1769", 512, 64, 30, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
-
-    { 0x0004FF11, "2103",  32,  8,  8, 4096, SectorTable_2103, CHIP_VARIANT_LPC2XXX },
-    { 0xFFF0FF12, "2104", 128, 16, 15, 8192, SectorTable_210x, CHIP_VARIANT_LPC2XXX },
-    { 0xFFF0FF22, "2105", 128, 32, 15, 8192, SectorTable_210x, CHIP_VARIANT_LPC2XXX },
-    { 0xFFF0FF32, "2106", 128, 64, 15, 8192, SectorTable_210x, CHIP_VARIANT_LPC2XXX },
-    { 0x0201FF01, "2109",  64,  8,  8, 4096, SectorTable_2109, CHIP_VARIANT_LPC2XXX },
-    { 0x0101FF12, "2114", 128, 16, 15, 8192, SectorTable_211x, CHIP_VARIANT_LPC2XXX },
-    { 0x0201FF12, "2119", 128, 16, 15, 8192, SectorTable_211x, CHIP_VARIANT_LPC2XXX },
-    { 0x0101FF13, "2124", 256, 16, 17, 8192, SectorTable_212x, CHIP_VARIANT_LPC2XXX },
-    { 0x0201FF13, "2129", 256, 16, 17, 8192, SectorTable_212x, CHIP_VARIANT_LPC2XXX },
-    { 0x0002FF01, "2131",  32,  8,  8, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x0002FF11, "2132",  64, 16,  9, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x0002FF12, "2134", 128, 16, 11, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x0002FF23, "2136", 256, 32, 15, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x0002FF25, "2138", 512, 32, 27, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x0402FF01, "2141",  32,  8,  8, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x0402FF11, "2142",  64, 16,  9, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x0402FF12, "2144", 128, 16, 11, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x0402FF23, "2146", 256, 40, 15, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x0402FF25, "2148", 512, 40, 27, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x0301FF13, "2194", 256, 16, 17, 8192, SectorTable_212x, CHIP_VARIANT_LPC2XXX },
-    { 0x0301FF12, "2210",   0, 16,  0, 8192, SectorTable_211x, CHIP_VARIANT_LPC2XXX }, /* table is a "don't care" */
-    { 0x0401FF12, "2212", 128, 16, 15, 8192, SectorTable_211x, CHIP_VARIANT_LPC2XXX },
-    { 0x0601FF13, "2214", 256, 16, 17, 8192, SectorTable_212x, CHIP_VARIANT_LPC2XXX },
+    { 0x0364002B, "1224.../101",  32,  8,  4, 4096, SectorTable_17xx, CHIP_VARIANT_LPC11XX },
+    { 0x0364202B, "1224.../121",  48, 12, 32, 4096, SectorTable_17xx, CHIP_VARIANT_LPC11XX },
+    { 0x0365002B, "1225.../301",  64, 16, 32, 4096, SectorTable_17xx, CHIP_VARIANT_LPC11XX },
+    { 0x0365202B, "1225.../321",  80, 20, 32, 4096, SectorTable_17xx, CHIP_VARIANT_LPC11XX },
+    { 0x0366002B, "1226",         96, 24, 32, 4096, SectorTable_17xx, CHIP_VARIANT_LPC11XX },
+    { 0x0367002B, "1227",        128, 32, 32, 4096, SectorTable_17xx, CHIP_VARIANT_LPC11XX },
+
+    { 0x2C42502B, "1311",          8,  4,  2, 2048, SectorTable_17xx, CHIP_VARIANT_LPC13XX },
+    { 0x2C40102B, "1313",         32,  8,  8, 4096, SectorTable_17xx, CHIP_VARIANT_LPC13XX },
+    { 0x3D01402B, "1342",          8,  4,  2, 2048, SectorTable_17xx, CHIP_VARIANT_LPC13XX },
+    { 0x3D00002B, "1343",         32,  8,  8, 4096, SectorTable_17xx, CHIP_VARIANT_LPC13XX },
+
+    { 0x25001118, "1751",         32,  8,  8, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x25001121, "1752",         64, 16, 16, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x25011722, "1754",        128, 32, 18, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x25011723, "1756",        256, 32, 22, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x25013F37, "1758",        512, 64, 30, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x25113737, "1759",        512, 64, 30, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x26011922, "1764",        128, 32, 18, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x26013733, "1765",        256, 64, 22, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x26013F33, "1766",        256, 64, 22, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x26012837, "1767",        512, 64, 30, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x26013F37, "1768",        512, 64, 30, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x26113F37, "1769",        512, 64, 30, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+
+    { 0x27011132, "1774",        128, 40, 18, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x27191F43, "1776",        256, 80, 22, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x27193747, "1777",        512, 96, 30, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x27193F47, "1778",        512, 96, 30, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x281D1743, "1785",        256, 80, 22, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x281D1F43, "1786",        256, 80, 22, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x281D3747, "1787",        512, 96, 30, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+    { 0x281D3F47, "1788",        512, 96, 30, 4096, SectorTable_17xx, CHIP_VARIANT_LPC17XX },
+
+    { 0x0004FF11, "2103",         32,  8,  8, 4096, SectorTable_2103, CHIP_VARIANT_LPC2XXX },
+    { 0xFFF0FF12, "2104",        128, 16, 15, 8192, SectorTable_210x, CHIP_VARIANT_LPC2XXX },
+    { 0xFFF0FF22, "2105",        128, 32, 15, 8192, SectorTable_210x, CHIP_VARIANT_LPC2XXX },
+    { 0xFFF0FF32, "2106",        128, 64, 15, 8192, SectorTable_210x, CHIP_VARIANT_LPC2XXX },
+    { 0x0201FF01, "2109",         64,  8,  8, 4096, SectorTable_2109, CHIP_VARIANT_LPC2XXX },
+    { 0x0101FF12, "2114",        128, 16, 15, 8192, SectorTable_211x, CHIP_VARIANT_LPC2XXX },
+    { 0x0201FF12, "2119",        128, 16, 15, 8192, SectorTable_211x, CHIP_VARIANT_LPC2XXX },
+    { 0x0101FF13, "2124",        256, 16, 17, 8192, SectorTable_212x, CHIP_VARIANT_LPC2XXX },
+    { 0x0201FF13, "2129",        256, 16, 17, 8192, SectorTable_212x, CHIP_VARIANT_LPC2XXX },
+    { 0x0002FF01, "2131",         32,  8,  8, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x0002FF11, "2132",         64, 16,  9, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x0002FF12, "2134",        128, 16, 11, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x0002FF23, "2136",        256, 32, 15, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x0002FF25, "2138",        512, 32, 27, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x0402FF01, "2141",         32,  8,  8, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x0402FF11, "2142",         64, 16,  9, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x0402FF12, "2144",        128, 16, 11, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x0402FF23, "2146",        256, 40, 15, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x0402FF25, "2148",        512, 40, 27, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x0301FF13, "2194",        256, 16, 17, 8192, SectorTable_212x, CHIP_VARIANT_LPC2XXX },
+    { 0x0301FF12, "2210",          0, 16,  0, 8192, SectorTable_211x, CHIP_VARIANT_LPC2XXX }, /* table is a "don't care" */
+    { 0x0401FF12, "2212",        128, 16, 15, 8192, SectorTable_211x, CHIP_VARIANT_LPC2XXX },
+    { 0x0601FF13, "2214",        256, 16, 17, 8192, SectorTable_212x, CHIP_VARIANT_LPC2XXX },
     /*            "2290"; same id as the LPC2210 */
-    { 0x0401FF13, "2292", 256, 16, 17, 8192, SectorTable_212x, CHIP_VARIANT_LPC2XXX },
-    { 0x0501FF13, "2294", 256, 16, 17, 8192, SectorTable_212x, CHIP_VARIANT_LPC2XXX },
-    { 0x00000000, "2361", 128, 34, 11, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x00000000, "2362", 128, 34, 11, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x1600F902, "2364", 128, 34, 11, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x1600E823, "2365", 256, 58, 15, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x1600F923, "2366", 256, 58, 15, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x1600E825, "2367", 512, 58, 15, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x1600F925, "2368", 512, 58, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x1700E825, "2377", 512, 58, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x1700FD25, "2378", 512, 58, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x1800F935, "2387", 512, 98, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x1800FF35, "2388", 512, 98, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x1500FF35, "2458", 512, 98, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x1600FF30, "2460",   0, 98,  0, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x1600FF35, "2468", 512, 98, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x1701FF30, "2470",   0, 98,  0, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
-    { 0x1701FF35, "2478", 512, 98, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX }
+    { 0x0401FF13, "2292",        256, 16, 17, 8192, SectorTable_212x, CHIP_VARIANT_LPC2XXX },
+    { 0x0501FF13, "2294",        256, 16, 17, 8192, SectorTable_212x, CHIP_VARIANT_LPC2XXX },
+    { 0x00000000, "2361",        128, 34, 11, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x00000000, "2362",        128, 34, 11, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x0603FB02, "2364",        128, 34, 11, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX }, /* From UM10211 Rev. 01 -- 6 July 2007 */
+    { 0x1600F902, "2364",        128, 34, 11, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x1600E823, "2365",        256, 58, 15, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x0603FB23, "2366",        256, 58, 15, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX }, /* From UM10211 Rev. 01 -- 6 July 2007 */
+    { 0x1600F923, "2366",        256, 58, 15, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x1600E825, "2367",        512, 58, 15, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x0603FB25, "2368",        512, 58, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX }, /* From UM10211 Rev. 01 -- 6 July 2007 */
+    { 0x1600F925, "2368",        512, 58, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x1700E825, "2377",        512, 58, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x0703FF25, "2378",        512, 58, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX }, /* From UM10211 Rev. 01 -- 6 July 2007 */
+    { 0x1600FD25, "2378",        512, 58, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX }, /* From UM10211 Rev. 01 -- 29 October 2007 */
+    { 0x1700FD25, "2378",        512, 58, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x1700FF35, "2387",        512, 98, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX }, /* From UM10211 Rev. 03 -- 25 August 2008 */
+    { 0x1800F935, "2387",        512, 98, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x1800FF35, "2388",        512, 98, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x1500FF35, "2458",        512, 98, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x1600FF30, "2460",          0, 98,  0, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x1600FF35, "2468",        512, 98, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x1701FF30, "2470",          0, 98,  0, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX },
+    { 0x1701FF35, "2478",        512, 98, 28, 4096, SectorTable_213x, CHIP_VARIANT_LPC2XXX }
 };
 
 /***************************** PHILIPS Download *********************************/
@@ -406,80 +432,6 @@ int PhilipsDownload(ISP_ENVIRONMENT *IspEnvironment)
                               sendbuf15, sendbuf16, sendbuf17, sendbuf18, sendbuf19};
 #endif
 
-    if (!IspEnvironment->DetectOnly)
-    {
-        // Build up uuencode table
-        uuencode_table[0] = 0x60;           // 0x20 is translated to 0x60 !
-
-        for (i = 1; i < 64; i++)
-        {
-            uuencode_table[i] = (char)(0x20 + i);
-        }
-
-        if(LPCtypes[IspEnvironment->DetectedDevice].ChipVariant == CHIP_VARIANT_LPC2XXX)
-        {
-            // Patch 0x14, otherwise it is not running and jumps to boot mode
-
-            ivt_CRC = 0;
-
-            // Clear the vector at 0x14 so it doesn't affect the checksum:
-            for (i = 0; i < 4; i++)
-            {
-                IspEnvironment->BinaryContent[i + 0x14] = 0;
-            }
-
-            // Calculate a native checksum of the little endian vector table:
-            for (i = 0; i < (4 * 8);) {
-                ivt_CRC += IspEnvironment->BinaryContent[i++];
-                ivt_CRC += IspEnvironment->BinaryContent[i++] << 8;
-                ivt_CRC += IspEnvironment->BinaryContent[i++] << 16;
-                ivt_CRC += IspEnvironment->BinaryContent[i++] << 24;
-            }
-
-            /* Negate the result and place in the vector at 0x14 as little endian
-            * again. The resulting vector table should checksum to 0. */
-            ivt_CRC = (unsigned long) (0 - ivt_CRC);
-            for (i = 0; i < 4; i++)
-            {
-                IspEnvironment->BinaryContent[i + 0x14] = (unsigned char)(ivt_CRC >> (8 * i));
-            }
-
-            DebugPrintf(3, "Position 0x14 patched: ivt_CRC = 0x%08lX\n", ivt_CRC);
-        }
-        else if(LPCtypes[IspEnvironment->DetectedDevice].ChipVariant == CHIP_VARIANT_LPC17XX ||
-                LPCtypes[IspEnvironment->DetectedDevice].ChipVariant == CHIP_VARIANT_LPC13XX ||
-                LPCtypes[IspEnvironment->DetectedDevice].ChipVariant == CHIP_VARIANT_LPC11XX)
-        {
-            // Patch 0x1C, otherwise it is not running and jumps to boot mode
-
-            ivt_CRC = 0;
-
-            // Clear the vector at 0x1C so it doesn't affect the checksum:
-            for (i = 0; i < 4; i++)
-            {
-                IspEnvironment->BinaryContent[i + 0x1C] = 0;
-            }
-
-            // Calculate a native checksum of the little endian vector table:
-            for (i = 0; i < (4 * 8);) {
-                ivt_CRC += IspEnvironment->BinaryContent[i++];
-                ivt_CRC += IspEnvironment->BinaryContent[i++] << 8;
-                ivt_CRC += IspEnvironment->BinaryContent[i++] << 16;
-                ivt_CRC += IspEnvironment->BinaryContent[i++] << 24;
-            }
-
-            /* Negate the result and place in the vector at 0x1C as little endian
-            * again. The resulting vector table should checksum to 0. */
-            ivt_CRC = (unsigned long) (0 - ivt_CRC);
-            for (i = 0; i < 4; i++)
-            {
-                IspEnvironment->BinaryContent[i + 0x1C] = (unsigned char)(ivt_CRC >> (8 * i));
-            }
-
-            DebugPrintf(3, "Position 0x1C patched: ivt_CRC = 0x%08lX\n", ivt_CRC);
-        }
-    }
-
     DebugPrintf(2, "Synchronizing (ESC to abort)");
 
     PrepareKeyboardTtySettings();
@@ -690,6 +642,80 @@ int PhilipsDownload(ISP_ENVIRONMENT *IspEnvironment)
     }
     DebugPrintf(2, " (0x%X)\n", Pos);//strippedAnswer);
 
+    if (!IspEnvironment->DetectOnly)
+    {
+        // Build up uuencode table
+        uuencode_table[0] = 0x60;           // 0x20 is translated to 0x60 !
+
+        for (i = 1; i < 64; i++)
+        {
+            uuencode_table[i] = (char)(0x20 + i);
+        }
+
+        if(LPCtypes[IspEnvironment->DetectedDevice].ChipVariant == CHIP_VARIANT_LPC2XXX)
+        {
+            // Patch 0x14, otherwise it is not running and jumps to boot mode
+
+            ivt_CRC = 0;
+
+            // Clear the vector at 0x14 so it doesn't affect the checksum:
+            for (i = 0; i < 4; i++)
+            {
+                IspEnvironment->BinaryContent[i + 0x14] = 0;
+            }
+
+            // Calculate a native checksum of the little endian vector table:
+            for (i = 0; i < (4 * 8);) {
+                ivt_CRC += IspEnvironment->BinaryContent[i++];
+                ivt_CRC += IspEnvironment->BinaryContent[i++] << 8;
+                ivt_CRC += IspEnvironment->BinaryContent[i++] << 16;
+                ivt_CRC += IspEnvironment->BinaryContent[i++] << 24;
+            }
+
+            /* Negate the result and place in the vector at 0x14 as little endian
+            * again. The resulting vector table should checksum to 0. */
+            ivt_CRC = (unsigned long) (0 - ivt_CRC);
+            for (i = 0; i < 4; i++)
+            {
+                IspEnvironment->BinaryContent[i + 0x14] = (unsigned char)(ivt_CRC >> (8 * i));
+            }
+
+            DebugPrintf(3, "Position 0x14 patched: ivt_CRC = 0x%08lX\n", ivt_CRC);
+        }
+        else if(LPCtypes[IspEnvironment->DetectedDevice].ChipVariant == CHIP_VARIANT_LPC17XX ||
+                LPCtypes[IspEnvironment->DetectedDevice].ChipVariant == CHIP_VARIANT_LPC13XX ||
+                LPCtypes[IspEnvironment->DetectedDevice].ChipVariant == CHIP_VARIANT_LPC11XX)
+        {
+            // Patch 0x1C, otherwise it is not running and jumps to boot mode
+
+            ivt_CRC = 0;
+
+            // Clear the vector at 0x1C so it doesn't affect the checksum:
+            for (i = 0; i < 4; i++)
+            {
+                IspEnvironment->BinaryContent[i + 0x1C] = 0;
+            }
+
+            // Calculate a native checksum of the little endian vector table:
+            for (i = 0; i < (4 * 8);) {
+                ivt_CRC += IspEnvironment->BinaryContent[i++];
+                ivt_CRC += IspEnvironment->BinaryContent[i++] << 8;
+                ivt_CRC += IspEnvironment->BinaryContent[i++] << 16;
+                ivt_CRC += IspEnvironment->BinaryContent[i++] << 24;
+            }
+
+            /* Negate the result and place in the vector at 0x1C as little endian
+            * again. The resulting vector table should checksum to 0. */
+            ivt_CRC = (unsigned long) (0 - ivt_CRC);
+            for (i = 0; i < 4; i++)
+            {
+                IspEnvironment->BinaryContent[i + 0x1C] = (unsigned char)(ivt_CRC >> (8 * i));
+            }
+
+            DebugPrintf(3, "Position 0x1C patched: ivt_CRC = 0x%08lX\n", ivt_CRC);
+        }
+    }
+
 #if 0
     DebugPrintf(2, "Read Unique ID:\n");
 
@@ -1159,7 +1185,8 @@ int PhilipsDownload(ISP_ENVIRONMENT *IspEnvironment)
                 LPCtypes[IspEnvironment->DetectedDevice].ChipVariant == CHIP_VARIANT_LPC13XX ||
                 LPCtypes[IspEnvironment->DetectedDevice].ChipVariant == CHIP_VARIANT_LPC11XX)
         {
-            sprintf(tmpString, "G %ld T\n", IspEnvironment->StartAddress & ~1);
+            // sprintf(tmpString, "G %ld T\n", IspEnvironment->StartAddress & ~1);
+            sprintf(tmpString, "G 0 T\n");
         }
         else
         {
@@ -1188,7 +1215,8 @@ int PhilipsDownload(ISP_ENVIRONMENT *IspEnvironment)
                     LPCtypes[IspEnvironment->DetectedDevice].ChipVariant == CHIP_VARIANT_LPC13XX ||
                     LPCtypes[IspEnvironment->DetectedDevice].ChipVariant == CHIP_VARIANT_LPC11XX)
             {
-                sprintf(ExpectedAnswer, "G %ld T\n0", IspEnvironment->StartAddress & ~1);
+                // sprintf(ExpectedAnswer, "G %ld T\n0", IspEnvironment->StartAddress & ~1);
+                sprintf(ExpectedAnswer, "G 0 T\n0");
             }
             else
             {
@@ -1196,6 +1224,10 @@ int PhilipsDownload(ISP_ENVIRONMENT *IspEnvironment)
                 exit(1);
             }
 
+            // printf("realsize=%d\n", realsize);
+            // printf("Answer=%s\n", Answer);
+            // printf("ExpectedAnswer=%s\n", ExpectedAnswer);
+
             if (realsize == 0 || strncmp((const char *)Answer, /*cmdstr*/ExpectedAnswer, strlen(/*cmdstr*/ExpectedAnswer)) != 0)
             {
                 DebugPrintf(2, "Failed to run the new downloaded code: ");
diff --git a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.dsp b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.dsp
index 935210c..8590d66 100644
--- a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.dsp
+++ b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.dsp
@@ -1,100 +1,100 @@
-# Microsoft Developer Studio Project File - Name="lpcprog" - Package Owner=<4>
-# Microsoft Developer Studio Generated Build File, Format Version 6.00
-# ** DO NOT EDIT **
-
-# TARGTYPE "Win32 (x86) Console Application" 0x0103
-
-CFG=lpcprog - Win32 Debug
-!MESSAGE This is not a valid makefile. To build this project using NMAKE,
-!MESSAGE use the Export Makefile command and run
-!MESSAGE 
-!MESSAGE NMAKE /f "lpcprog.mak".
-!MESSAGE 
-!MESSAGE You can specify a configuration when running NMAKE
-!MESSAGE by defining the macro CFG on the command line. For example:
-!MESSAGE 
-!MESSAGE NMAKE /f "lpcprog.mak" CFG="lpcprog - Win32 Debug"
-!MESSAGE 
-!MESSAGE Possible choices for configuration are:
-!MESSAGE 
-!MESSAGE "lpcprog - Win32 Release" (based on "Win32 (x86) Console Application")
-!MESSAGE "lpcprog - Win32 Debug" (based on "Win32 (x86) Console Application")
-!MESSAGE 
-
-# Begin Project
-# PROP AllowPerConfigDependencies 0
-# PROP Scc_ProjName ""
-# PROP Scc_LocalPath ""
-CPP=cl.exe
-RSC=rc.exe
-
-!IF  "$(CFG)" == "lpcprog - Win32 Release"
-
-# PROP BASE Use_MFC 0
-# PROP BASE Use_Debug_Libraries 0
-# PROP BASE Output_Dir "Release"
-# PROP BASE Intermediate_Dir "Release"
-# PROP BASE Target_Dir ""
-# PROP Use_MFC 0
-# PROP Use_Debug_Libraries 0
-# PROP Output_Dir "Release"
-# PROP Intermediate_Dir "Release"
-# PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD BASE RSC /l 0x809 /d "NDEBUG"
-# ADD RSC /l 0x809 /d "NDEBUG"
-BSC32=bscmake.exe
-# ADD BASE BSC32 /nologo
-# ADD BSC32 /nologo
-LINK32=link.exe
-# ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /machine:I386
-# ADD LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /machine:I386
-
-!ELSEIF  "$(CFG)" == "lpcprog - Win32 Debug"
-
-# PROP BASE Use_MFC 0
-# PROP BASE Use_Debug_Libraries 1
-# PROP BASE Output_Dir "Debug"
-# PROP BASE Intermediate_Dir "Debug"
-# PROP BASE Target_Dir ""
-# PROP Use_MFC 0
-# PROP Use_Debug_Libraries 1
-# PROP Output_Dir "Debug"
-# PROP Intermediate_Dir "Debug"
-# PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /GZ /c
-# ADD CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /GZ /c
-# ADD BASE RSC /l 0x809 /d "_DEBUG"
-# ADD RSC /l 0x809 /d "_DEBUG"
-BSC32=bscmake.exe
-# ADD BASE BSC32 /nologo
-# ADD BSC32 /nologo
-LINK32=link.exe
-# ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /pdbtype:sept
-# ADD LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /pdbtype:sept
-
-!ENDIF 
-
-# Begin Target
-
-# Name "lpcprog - Win32 Release"
-# Name "lpcprog - Win32 Debug"
-# Begin Source File
-
-SOURCE=.\adprog.c
-# End Source File
-# Begin Source File
-
-SOURCE=.\lpc21isp.c
-# End Source File
-# Begin Source File
-
-SOURCE=.\lpcprog.c
-# End Source File
-# Begin Source File
-
-SOURCE=.\lpcterm.c
-# End Source File
-# End Target
-# End Project
+# Microsoft Developer Studio Project File - Name="lpcprog" - Package Owner=<4>
+# Microsoft Developer Studio Generated Build File, Format Version 6.00
+# ** DO NOT EDIT **
+
+# TARGTYPE "Win32 (x86) Console Application" 0x0103
+
+CFG=lpcprog - Win32 Debug
+!MESSAGE This is not a valid makefile. To build this project using NMAKE,
+!MESSAGE use the Export Makefile command and run
+!MESSAGE 
+!MESSAGE NMAKE /f "lpcprog.mak".
+!MESSAGE 
+!MESSAGE You can specify a configuration when running NMAKE
+!MESSAGE by defining the macro CFG on the command line. For example:
+!MESSAGE 
+!MESSAGE NMAKE /f "lpcprog.mak" CFG="lpcprog - Win32 Debug"
+!MESSAGE 
+!MESSAGE Possible choices for configuration are:
+!MESSAGE 
+!MESSAGE "lpcprog - Win32 Release" (based on "Win32 (x86) Console Application")
+!MESSAGE "lpcprog - Win32 Debug" (based on "Win32 (x86) Console Application")
+!MESSAGE 
+
+# Begin Project
+# PROP AllowPerConfigDependencies 0
+# PROP Scc_ProjName ""
+# PROP Scc_LocalPath ""
+CPP=cl.exe
+RSC=rc.exe
+
+!IF  "$(CFG)" == "lpcprog - Win32 Release"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 0
+# PROP BASE Output_Dir "Release"
+# PROP BASE Intermediate_Dir "Release"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 0
+# PROP Output_Dir "Release"
+# PROP Intermediate_Dir "Release"
+# PROP Target_Dir ""
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE RSC /l 0x809 /d "NDEBUG"
+# ADD RSC /l 0x809 /d "NDEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LINK32=link.exe
+# ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /machine:I386
+# ADD LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /machine:I386
+
+!ELSEIF  "$(CFG)" == "lpcprog - Win32 Debug"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 1
+# PROP BASE Output_Dir "Debug"
+# PROP BASE Intermediate_Dir "Debug"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 1
+# PROP Output_Dir "Debug"
+# PROP Intermediate_Dir "Debug"
+# PROP Target_Dir ""
+# ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /GZ /c
+# ADD CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /GZ /c
+# ADD BASE RSC /l 0x809 /d "_DEBUG"
+# ADD RSC /l 0x809 /d "_DEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LINK32=link.exe
+# ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /pdbtype:sept
+# ADD LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /pdbtype:sept
+
+!ENDIF 
+
+# Begin Target
+
+# Name "lpcprog - Win32 Release"
+# Name "lpcprog - Win32 Debug"
+# Begin Source File
+
+SOURCE=.\adprog.c
+# End Source File
+# Begin Source File
+
+SOURCE=.\lpc21isp.c
+# End Source File
+# Begin Source File
+
+SOURCE=.\lpcprog.c
+# End Source File
+# Begin Source File
+
+SOURCE=.\lpcterm.c
+# End Source File
+# End Target
+# End Project
diff --git a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.dsw b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.dsw
index 30bcfd4..50aa31a 100644
--- a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.dsw
+++ b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.dsw
@@ -1,29 +1,29 @@
-Microsoft Developer Studio Workspace File, Format Version 6.00
-# WARNING: DO NOT EDIT OR DELETE THIS WORKSPACE FILE!
-
-###############################################################################
-
-Project: "lpcprog"=.\lpcprog.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Global:
-
-Package=<5>
-{{{
-}}}
-
-Package=<3>
-{{{
-}}}
-
-###############################################################################
-
+Microsoft Developer Studio Workspace File, Format Version 6.00
+# WARNING: DO NOT EDIT OR DELETE THIS WORKSPACE FILE!
+
+###############################################################################
+
+Project: "lpcprog"=.\lpcprog.dsp - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Global:
+
+Package=<5>
+{{{
+}}}
+
+Package=<3>
+{{{
+}}}
+
+###############################################################################
+
diff --git a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.h b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.h
index e56e5fe..31a07ef 100644
--- a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.h
+++ b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcprog.h
@@ -1,125 +1,125 @@
-/******************************************************************************
-
-Project:           Portable command line ISP for Philips LPC2000 family
-                   and Analog Devices ADUC70xx
-
-Filename:          lpcprog.h
-
-Compiler:          Microsoft VC 6/7, GCC Cygwin, GCC Linux, GCC ARM ELF
-
-Author:            Martin Maurer (Martin.Maurer@clibb.de)
-
-Copyright:         (c) Martin Maurer 2003-2010, All rights reserved
-Portions Copyright (c) by Aeolus Development 2004 http://www.aeolusdevelopment.com
-
-    This file is part of lpc21isp.
-
-    lpc21isp is free software: you can redistribute it and/or modify
-    it under the terms of the GNU Lesser General Public License as published by
-    the Free Software Foundation, either version 3 of the License, or
-    any later version.
-
-    lpc21isp is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU Lesser General Public License for more details.
-
-    You should have received a copy of the GNU Lesser General Public License
-    and GNU General Public License along with lpc21isp.
-    If not, see <http://www.gnu.org/licenses/>.
-*/
-
-/* LPC_RAMSTART, LPC_RAMBASE
-*
-* Used in PhilipsDownload() to decide whether to Flash code or just place in in RAM
-* (works for .hex files only)
-*
-* LPC_RAMSTART - the Physical start address of the SRAM
-* LPC_RAMBASE  - the base address where downloading starts.
-*                Note that any code in the .hex file that resides in 0x4000,0000 ~ 0x4000,0200
-*                will _not_ be written to the LPCs SRAM.
-*                This is due to the fact that 0x4000,0040 - 0x4000,0200 is used by the bootrom.
-*                Any interrupt vectors must be copied to 0x4000,0000 and remapped to 0x0000,0000
-*                by the startup code.
-*/
-#define LPC_RAMSTART_LPC2XXX    0x40000000L
-#define LPC_RAMBASE_LPC2XXX     0x40000200L
-
-#define LPC_RAMSTART_LPC17XX    0x10000000L
-#define LPC_RAMBASE_LPC17XX     0x10000200L
-
-#define LPC_RAMSTART_LPC13XX    0x10000000L
-#define LPC_RAMBASE_LPC13XX     0x10000300L
-
-#define LPC_RAMSTART_LPC11XX    0x10000000L
-#define LPC_RAMBASE_LPC11XX     0x10000300L
-
-/* Return values used by PhilipsDownload(): reserving all values from 0x1000 to 0x1FFF */
-
-#define NO_ANSWER_WDT       0x1000
-#define NO_ANSWER_QM        0x1001
-#define NO_ANSWER_SYNC      0x1002
-#define NO_ANSWER_OSC       0x1003
-#define NO_ANSWER_RBV       0x1004
-#define NO_ANSWER_RPID      0x1005
-#define ERROR_WRITE_DATA    0x1006
-#define ERROR_WRITE_CRC     0x1007
-#define ERROR_WRITE_CRC2    0x1008
-#define PROGRAM_TOO_LARGE   0x1009
-
-#define USER_ABORT_SYNC     0x100A   /* User aborted synchronisation process */
-
-#define UNLOCK_ERROR        0x1100   /* return value is 0x1100 + philips ISP returned value (0 to 255) */
-#define WRONG_ANSWER_PREP   0x1200   /* return value is 0x1200 + philips ISP returned value (0 to 255) */
-#define WRONG_ANSWER_ERAS   0x1300   /* return value is 0x1300 + philips ISP returned value (0 to 255) */
-#define WRONG_ANSWER_WRIT   0x1400   /* return value is 0x1400 + philips ISP returned value (0 to 255) */
-#define WRONG_ANSWER_PREP2  0x1500   /* return value is 0x1500 + philips ISP returned value (0 to 255) */
-#define WRONG_ANSWER_COPY   0x1600   /* return value is 0x1600 + philips ISP returned value (0 to 255) */
-#define FAILED_RUN          0x1700   /* return value is 0x1700 + philips ISP returned value (0 to 255) */
-
-#if defined COMPILE_FOR_LPC21
-#ifndef WIN32
-#define LPC_BSL_PIN         13
-#define LPC_RESET_PIN       47
-#define LPC_RESET(in)       NAsetGPIOpin(LPC_RESET_PIN, (in))
-#define LPC_BSL(in)         NAsetGPIOpin(LPC_BSL_PIN,   (in))
-#endif // WIN32
-#endif // COMPILE_FOR_LPC21
-
-
-/* LPC_FLASHMASK
-*
-* LPC_FLASHMASK - bitmask to define the maximum size of the Filesize to download.
-*                 LoadFile() will check any new segment address record (03) or extended linear
-*                 address record (04) to see if the addressed 64 kByte data block still falls
-*                 in the max. flash size.
-*                 LoadFile() will not load any files that are larger than this size.
-*/
-#define LPC_FLASHMASK  0xFFC00000 /* 22 bits = 4 MB */
-
-typedef enum
-  {
-  CHIP_VARIANT_LPC2XXX,
-  CHIP_VARIANT_LPC17XX,
-  CHIP_VARIANT_LPC13XX,
-  CHIP_VARIANT_LPC11XX
-  } CHIP_VARIANT;
-
-typedef struct
-{
-    const unsigned long  id;
-    const char *Product;
-    const unsigned int   FlashSize;     /* in kiB, for informational purposes only */
-    const unsigned int   RAMSize;       /* in kiB, for informational purposes only */
-          unsigned int   FlashSectors;  /* total number of sectors */
-          unsigned int   MaxCopySize;   /* maximum size that can be copied to Flash in a single command */
-    const unsigned int  *SectorTable;   /* pointer to a sector table with constant the sector sizes */
-    const CHIP_VARIANT   ChipVariant;
-} LPC_DEVICE_TYPE;
-
-int PhilipsDownload(ISP_ENVIRONMENT *IspEnvironment);
-
-unsigned long ReturnValueLpcRamStart(ISP_ENVIRONMENT *IspEnvironment);
-
-unsigned long ReturnValueLpcRamBase(ISP_ENVIRONMENT *IspEnvironment);
-
+/******************************************************************************
+
+Project:           Portable command line ISP for Philips LPC2000 family
+                   and Analog Devices ADUC70xx
+
+Filename:          lpcprog.h
+
+Compiler:          Microsoft VC 6/7, GCC Cygwin, GCC Linux, GCC ARM ELF
+
+Author:            Martin Maurer (Martin.Maurer@clibb.de)
+
+Copyright:         (c) Martin Maurer 2003-2010, All rights reserved
+Portions Copyright (c) by Aeolus Development 2004 http://www.aeolusdevelopment.com
+
+    This file is part of lpc21isp.
+
+    lpc21isp is free software: you can redistribute it and/or modify
+    it under the terms of the GNU Lesser General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    any later version.
+
+    lpc21isp is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    and GNU General Public License along with lpc21isp.
+    If not, see <http://www.gnu.org/licenses/>.
+*/
+
+/* LPC_RAMSTART, LPC_RAMBASE
+*
+* Used in PhilipsDownload() to decide whether to Flash code or just place in in RAM
+* (works for .hex files only)
+*
+* LPC_RAMSTART - the Physical start address of the SRAM
+* LPC_RAMBASE  - the base address where downloading starts.
+*                Note that any code in the .hex file that resides in 0x4000,0000 ~ 0x4000,0200
+*                will _not_ be written to the LPCs SRAM.
+*                This is due to the fact that 0x4000,0040 - 0x4000,0200 is used by the bootrom.
+*                Any interrupt vectors must be copied to 0x4000,0000 and remapped to 0x0000,0000
+*                by the startup code.
+*/
+#define LPC_RAMSTART_LPC2XXX    0x40000000L
+#define LPC_RAMBASE_LPC2XXX     0x40000200L
+
+#define LPC_RAMSTART_LPC17XX    0x10000000L
+#define LPC_RAMBASE_LPC17XX     0x10000200L
+
+#define LPC_RAMSTART_LPC13XX    0x10000000L
+#define LPC_RAMBASE_LPC13XX     0x10000300L
+
+#define LPC_RAMSTART_LPC11XX    0x10000000L
+#define LPC_RAMBASE_LPC11XX     0x10000300L
+
+/* Return values used by PhilipsDownload(): reserving all values from 0x1000 to 0x1FFF */
+
+#define NO_ANSWER_WDT       0x1000
+#define NO_ANSWER_QM        0x1001
+#define NO_ANSWER_SYNC      0x1002
+#define NO_ANSWER_OSC       0x1003
+#define NO_ANSWER_RBV       0x1004
+#define NO_ANSWER_RPID      0x1005
+#define ERROR_WRITE_DATA    0x1006
+#define ERROR_WRITE_CRC     0x1007
+#define ERROR_WRITE_CRC2    0x1008
+#define PROGRAM_TOO_LARGE   0x1009
+
+#define USER_ABORT_SYNC     0x100A   /* User aborted synchronisation process */
+
+#define UNLOCK_ERROR        0x1100   /* return value is 0x1100 + philips ISP returned value (0 to 255) */
+#define WRONG_ANSWER_PREP   0x1200   /* return value is 0x1200 + philips ISP returned value (0 to 255) */
+#define WRONG_ANSWER_ERAS   0x1300   /* return value is 0x1300 + philips ISP returned value (0 to 255) */
+#define WRONG_ANSWER_WRIT   0x1400   /* return value is 0x1400 + philips ISP returned value (0 to 255) */
+#define WRONG_ANSWER_PREP2  0x1500   /* return value is 0x1500 + philips ISP returned value (0 to 255) */
+#define WRONG_ANSWER_COPY   0x1600   /* return value is 0x1600 + philips ISP returned value (0 to 255) */
+#define FAILED_RUN          0x1700   /* return value is 0x1700 + philips ISP returned value (0 to 255) */
+
+#if defined COMPILE_FOR_LPC21
+#ifndef WIN32
+#define LPC_BSL_PIN         13
+#define LPC_RESET_PIN       47
+#define LPC_RESET(in)       NAsetGPIOpin(LPC_RESET_PIN, (in))
+#define LPC_BSL(in)         NAsetGPIOpin(LPC_BSL_PIN,   (in))
+#endif // WIN32
+#endif // COMPILE_FOR_LPC21
+
+
+/* LPC_FLASHMASK
+*
+* LPC_FLASHMASK - bitmask to define the maximum size of the Filesize to download.
+*                 LoadFile() will check any new segment address record (03) or extended linear
+*                 address record (04) to see if the addressed 64 kByte data block still falls
+*                 in the max. flash size.
+*                 LoadFile() will not load any files that are larger than this size.
+*/
+#define LPC_FLASHMASK  0xFFC00000 /* 22 bits = 4 MB */
+
+typedef enum
+  {
+  CHIP_VARIANT_LPC2XXX,
+  CHIP_VARIANT_LPC17XX,
+  CHIP_VARIANT_LPC13XX,
+  CHIP_VARIANT_LPC11XX
+  } CHIP_VARIANT;
+
+typedef struct
+{
+    const unsigned long  id;
+    const char *Product;
+    const unsigned int   FlashSize;     /* in kiB, for informational purposes only */
+    const unsigned int   RAMSize;       /* in kiB, for informational purposes only */
+          unsigned int   FlashSectors;  /* total number of sectors */
+          unsigned int   MaxCopySize;   /* maximum size that can be copied to Flash in a single command */
+    const unsigned int  *SectorTable;   /* pointer to a sector table with constant the sector sizes */
+    const CHIP_VARIANT   ChipVariant;
+} LPC_DEVICE_TYPE;
+
+int PhilipsDownload(ISP_ENVIRONMENT *IspEnvironment);
+
+unsigned long ReturnValueLpcRamStart(ISP_ENVIRONMENT *IspEnvironment);
+
+unsigned long ReturnValueLpcRamBase(ISP_ENVIRONMENT *IspEnvironment);
+
diff --git a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcterm.c b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcterm.c
index 1299fe2..556d224 100644
--- a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcterm.c
+++ b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcterm.c
@@ -1,137 +1,137 @@
-/******************************************************************************
-
-Project:           Portable command line ISP for Philips LPC2000 family
-                   and Analog Devices ADUC70xx
-
-Filename:          lpcterm.c
-
-Compiler:          Microsoft VC 6/7, GCC Cygwin, GCC Linux, GCC ARM ELF
-
-Author:            Martin Maurer (Martin.Maurer@clibb.de)
-
-Copyright:         (c) Martin Maurer 2003-2008, All rights reserved
-Portions Copyright (c) by Aeolus Development 2004 http://www.aeolusdevelopment.com
-
-    This file is part of lpc21isp.
-
-    lpc21isp is free software: you can redistribute it and/or modify
-    it under the terms of the GNU Lesser General Public License as published by
-    the Free Software Foundation, either version 3 of the License, or
-    any later version.
-
-    lpc21isp is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU Lesser General Public License for more details.
-
-    You should have received a copy of the GNU Lesser General Public License
-    and GNU General Public License along with lpc21isp.
-    If not, see <http://www.gnu.org/licenses/>.
-*/
-
-#if defined(_WIN32)
-#if !defined __BORLANDC__
-#include "StdAfx.h"
-#endif
-#endif // defined(_WIN32)
-#include "lpc21isp.h"
-#include "lpcterm.h"
-
-#ifdef TERMINAL_SUPPORT
-/***************************** Terminal *********************************/
-/**  Acts as a simple dumb terminal. Press 'ESC' to exit.
-*/
-BOOL CheckTerminalParameters(ISP_ENVIRONMENT *IspEnvironment, char* pstr)
-{
-    if (stricmp(pstr, "-localecho") == 0)
-    {
-        IspEnvironment->LocalEcho = 1;
-        DebugPrintf(3, "Local echo in terminal mode.\n");
-        return TRUE;
-    }
-
-    if (stricmp(pstr, "-term") == 0)
-    {
-        IspEnvironment->TerminalAfterUpload = 1;
-        DebugPrintf(3, "Invoke terminal after upload.\n");
-        return TRUE;
-    }
-
-    if (stricmp(pstr, "-termonly") == 0)
-    {
-        IspEnvironment->TerminalOnly    = 1;
-        IspEnvironment->ProgramChip    = 0;
-        DebugPrintf(3, "Only provide terminal.\n");
-        return TRUE;
-    }
-
-    return FALSE;
-}
-
-void Terminal(ISP_ENVIRONMENT *IspEnvironment)
-{
-    if (IspEnvironment->TerminalAfterUpload || IspEnvironment->TerminalOnly)
-    {
-        int           ch = 0;
-        char buffer[128];
-        int           fdlogfile = -1;
-        unsigned long realsize;
-
-        // When logging is switched on, output terminal output to lpc21isp.log
-        if (IspEnvironment->LogFile)
-        {
-            fdlogfile = open("lpc21isp.log", O_RDWR | O_BINARY | O_CREAT | O_TRUNC, 0777);
-        }
-
-        PrepareKeyboardTtySettings();
-
-        DebugPrintf(1, "Terminal started (press Escape to abort)\n\n");
-        fflush(stdout);
-
-        do
-        {
-            ReceiveComPort(IspEnvironment, buffer, sizeof(buffer) - 1, &realsize, 0,200);          // Check for received characters
-
-            if (realsize)
-            {
-                write(1, buffer, realsize);
-                fflush(stdout);
-                if (IspEnvironment->LogFile)     // When logging is turned on, then copy output to logfile
-                {
-                    write(fdlogfile, buffer, realsize);
-                }
-            }
-
-            // check for keypress, and write any out the port.
-            if (kbhit())
-            {
-                ch = getch();
-                if (ch == 0x1b)
-                {
-                    break;
-                }
-                buffer[0] = (unsigned char)ch;
-                buffer[1] = 0;
-
-                if (IspEnvironment->LocalEcho)
-                {
-                    write(1, buffer, 1);
-                }
-
-                SendComPort(IspEnvironment, buffer);
-            }
-        }
-        while (ch != 0x1b);
-
-        DebugPrintf(1, "\n\nTerminal stopped\n\n");
-        fflush(stdout);
-
-        ResetKeyboardTtySettings();
-
-        if (IspEnvironment->LogFile)
-        {
-            close(fdlogfile);
-        }
-    }
-}
-#endif
+/******************************************************************************
+
+Project:           Portable command line ISP for Philips LPC2000 family
+                   and Analog Devices ADUC70xx
+
+Filename:          lpcterm.c
+
+Compiler:          Microsoft VC 6/7, GCC Cygwin, GCC Linux, GCC ARM ELF
+
+Author:            Martin Maurer (Martin.Maurer@clibb.de)
+
+Copyright:         (c) Martin Maurer 2003-2008, All rights reserved
+Portions Copyright (c) by Aeolus Development 2004 http://www.aeolusdevelopment.com
+
+    This file is part of lpc21isp.
+
+    lpc21isp is free software: you can redistribute it and/or modify
+    it under the terms of the GNU Lesser General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    any later version.
+
+    lpc21isp is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    and GNU General Public License along with lpc21isp.
+    If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#if defined(_WIN32)
+#if !defined __BORLANDC__
+#include "StdAfx.h"
+#endif
+#endif // defined(_WIN32)
+#include "lpc21isp.h"
+#include "lpcterm.h"
+
+#ifdef TERMINAL_SUPPORT
+/***************************** Terminal *********************************/
+/**  Acts as a simple dumb terminal. Press 'ESC' to exit.
+*/
+BOOL CheckTerminalParameters(ISP_ENVIRONMENT *IspEnvironment, char* pstr)
+{
+    if (stricmp(pstr, "-localecho") == 0)
+    {
+        IspEnvironment->LocalEcho = 1;
+        DebugPrintf(3, "Local echo in terminal mode.\n");
+        return TRUE;
+    }
+
+    if (stricmp(pstr, "-term") == 0)
+    {
+        IspEnvironment->TerminalAfterUpload = 1;
+        DebugPrintf(3, "Invoke terminal after upload.\n");
+        return TRUE;
+    }
+
+    if (stricmp(pstr, "-termonly") == 0)
+    {
+        IspEnvironment->TerminalOnly    = 1;
+        IspEnvironment->ProgramChip    = 0;
+        DebugPrintf(3, "Only provide terminal.\n");
+        return TRUE;
+    }
+
+    return FALSE;
+}
+
+void Terminal(ISP_ENVIRONMENT *IspEnvironment)
+{
+    if (IspEnvironment->TerminalAfterUpload || IspEnvironment->TerminalOnly)
+    {
+        int           ch = 0;
+        char buffer[128];
+        int           fdlogfile = -1;
+        unsigned long realsize;
+
+        // When logging is switched on, output terminal output to lpc21isp.log
+        if (IspEnvironment->LogFile)
+        {
+            fdlogfile = open("lpc21isp.log", O_RDWR | O_BINARY | O_CREAT | O_TRUNC, 0777);
+        }
+
+        PrepareKeyboardTtySettings();
+
+        DebugPrintf(1, "Terminal started (press Escape to abort)\n\n");
+        fflush(stdout);
+
+        do
+        {
+            ReceiveComPort(IspEnvironment, buffer, sizeof(buffer) - 1, &realsize, 0,200);          // Check for received characters
+
+            if (realsize)
+            {
+                write(1, buffer, realsize);
+                fflush(stdout);
+                if (IspEnvironment->LogFile)     // When logging is turned on, then copy output to logfile
+                {
+                    write(fdlogfile, buffer, realsize);
+                }
+            }
+
+            // check for keypress, and write any out the port.
+            if (kbhit())
+            {
+                ch = getch();
+                if (ch == 0x1b)
+                {
+                    break;
+                }
+                buffer[0] = (unsigned char)ch;
+                buffer[1] = 0;
+
+                if (IspEnvironment->LocalEcho)
+                {
+                    write(1, buffer, 1);
+                }
+
+                SendComPort(IspEnvironment, buffer);
+            }
+        }
+        while (ch != 0x1b);
+
+        DebugPrintf(1, "\n\nTerminal stopped\n\n");
+        fflush(stdout);
+
+        ResetKeyboardTtySettings();
+
+        if (IspEnvironment->LogFile)
+        {
+            close(fdlogfile);
+        }
+    }
+}
+#endif
diff --git a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcterm.h b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcterm.h
index e7dd7ec..85ef129 100644
--- a/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcterm.h
+++ b/arch/arm/mach-lpc17cmsis/tools/lpc21isp/lpcterm.h
@@ -1,42 +1,42 @@
-/******************************************************************************
-
-Project:           Portable command line ISP for Philips LPC2000 family
-                   and Analog Devices ADUC70xx
-
-Filename:          lpcterm.h
-
-Compiler:          Microsoft VC 6/7, GCC Cygwin, GCC Linux, GCC ARM ELF
-
-Author:            Martin Maurer (Martin.Maurer@clibb.de)
-
-Copyright:         (c) Martin Maurer 2003-2008, All rights reserved
-Portions Copyright (c) by Aeolus Development 2004 http://www.aeolusdevelopment.com
-
-    This file is part of lpc21isp.
-
-    lpc21isp is free software: you can redistribute it and/or modify
-    it under the terms of the GNU Lesser General Public License as published by
-    the Free Software Foundation, either version 3 of the License, or
-    any later version.
-
-    lpc21isp is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU Lesser General Public License for more details.
-
-    You should have received a copy of the GNU Lesser General Public License
-    and GNU General Public License along with lpc21isp.
-    If not, see <http://www.gnu.org/licenses/>.
-*/
-
-#ifndef TRUE
-#define TRUE (1)
-#endif
-#ifndef FALSE
-#define FALSE (0)
-#endif
-
-typedef int BOOL;
-
-void Terminal(ISP_ENVIRONMENT *IspEnvironment);
-BOOL CheckTerminalParameters(ISP_ENVIRONMENT *IspEnvironment, char* pstr);
+/******************************************************************************
+
+Project:           Portable command line ISP for Philips LPC2000 family
+                   and Analog Devices ADUC70xx
+
+Filename:          lpcterm.h
+
+Compiler:          Microsoft VC 6/7, GCC Cygwin, GCC Linux, GCC ARM ELF
+
+Author:            Martin Maurer (Martin.Maurer@clibb.de)
+
+Copyright:         (c) Martin Maurer 2003-2008, All rights reserved
+Portions Copyright (c) by Aeolus Development 2004 http://www.aeolusdevelopment.com
+
+    This file is part of lpc21isp.
+
+    lpc21isp is free software: you can redistribute it and/or modify
+    it under the terms of the GNU Lesser General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    any later version.
+
+    lpc21isp is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public License
+    and GNU General Public License along with lpc21isp.
+    If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef TRUE
+#define TRUE (1)
+#endif
+#ifndef FALSE
+#define FALSE (0)
+#endif
+
+typedef int BOOL;
+
+void Terminal(ISP_ENVIRONMENT *IspEnvironment);
+BOOL CheckTerminalParameters(ISP_ENVIRONMENT *IspEnvironment, char* pstr);
-- 
1.7.3.4

